//File name: DES.h
//File function: This file is a class for DES arithmetic, it realized DES enctyption,
//               DES descryption, 3DES encryption and 3DES descryption.
//author: Zhu Zhenbo
//Date: June 28, 2007

#ifndef  _DES_H_
#define  _DES_H_

#define INT8U  unsigned char
#define INT16U unsigned short
#define INT32U unsigned int
#define TRUE   1
#define FALSE  0

#define IN
#define OUT
#define INOUT

#define EN0 0
#define DE1 1

#define SIZE_KSN_REG        10      // size of key serial number register
#define SIZE_3DES_KEY       16      // 3DES key size
#define SIZE_DES_KEY        8       // DES key size
#define NUM_FKEY_REG        21	    // # of future key registers

typedef struct {
    INT32U ek[32];
    INT32U dk[32];
}des_ctx;
/*
typedef struct
{
    unsigned char   keytype;
    unsigned long   encrypt_ctr;
    unsigned char   future_key_reg[NUM_FKEY_REG][SIZE_3DES_KEY + 1];
    unsigned char   initKSN[SIZE_KSN_REG];
} dukpt_xor_type;
*/
class  CDES
{
public:
    CDES();
    ~CDES();

    //Function:   single DES encryption
    //input:      Data, key, blocks
    //output:     Data
    void single_des_enc(INOUT INT8U *Data, IN INT8U *key);
    //Function:   single DES decryption
    //input:      Data, key, blocks
    //output:     Data
    void single_des_dec(INOUT INT8U *Data, IN INT8U *key);
    // Function:  Triple DES decrypt
    // Input:     Data,key,blocks
    // Output:    Data
    void triple_des_enc(INOUT INT8U *Data, IN INT8U *key);
    // Function:  Triple DES decrypt
    // Input:     Data,key,blocks
    // Output:    Data
    void triple_des_dec(INOUT INT8U *Data, IN INT8U *key);
	//Exclude ored between source1 and source2,  
	//and the result is in source1
	void memxor(INOUT INT8U* source1, IN INT8U* source2, IN INT16U length);
    //if type is zero, then use single des encryption
    //else use triple des encryption.
	void DEA_encryption(INT8U type, INT8U* data, INT8U* key);
    //if type is zero, then use single des encryption
    //else use triple des encryption.
    void DEA_decryption(INT8U type, INT8U* data, INT8U* key);
	//triple des encryption 
    //every block has 8 bytes data
    void   des_cbc_encryption( INT8U type,
		                       INT8U* data, 
		                       INT8U* key, 
							   INT8U* init_vector, 
							   INT16U blocks);
	//decrypt the cipher with 3DES algorithm in CBC mode if defined USE_ENCRYPTION
    //else it will be returned right away.
    void  des_cbc_decryption( INT8U type,
		                      INT8U* cipher, 
						      INT8U* key, 
						      INT8U* init_vector, 
					          INT16U blocks);

private:
    des_ctx dctx;
	unsigned int MemCpy(INT8U *aucmDest, INT8U *aucmSrc, INT32U auiCount);
    void deskey(INT8U *key, short edf);
    void cookey(register INT32U *raw1);
    void usekey(register INT32U *from);
    void cpkey(register INT32U *uinto);
    void des_key(des_ctx *dc,INT8U *key);
    void des(INT8U *inblock, INT8U *outblock);
    void scrunch(register INT8U *outof, register INT32U *uinto);
    void unscrun(register INT32U *outof, register INT8U *uinto);
    void desfunc(register INT32U *block, register INT32U *keys);
    void des_enc(INT8U *Data, INT32U blocks);
    void des_dec(INT8U *Data, INT32U blocks);
};

#endif  //_DES_H_

