// MSRItfUSBHID.h: interface for the CMSRItfUSBHID class.
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MSRITFUSBHID_H__D2FEED46_5BB6_406F_8CCB_1B070B6921CE__INCLUDED_)
#define AFX_MSRITFUSBHID_H__D2FEED46_5BB6_406F_8CCB_1B070B6921CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MSRItf.h"
extern "C" {
#include "hid.h"
}

#define HID_DEVICE_ATTRIBUTES	MSR_DEV_ATTR
#define PHID_DEVICE_ATTRIBUTES	PMSR_DEV_ATTR

	
class CMSRItfUSBHID : public CMSRItf{
public:
	BOOL m_bPortOpened;
	CMSRItfUSBHID(INTERFACE_TYPE emItfType);
	virtual ~CMSRItfUSBHID();
	BOOL EnumMSRDevice2(INTERFACE_TYPE *pemItfType,ULONG ulIndex,CString& strDevName);	
	virtual BOOL OpenMSRDevice(ULONG ulIndex );
	virtual BOOL OpenMSRDeviceByName( LPCTSTR lpszName);
	virtual BOOL CloseMSRDevice();
	virtual BOOL SendCommand(BYTE* pCmdBuf,ULONG cbCmdBuf,PBYTE pRetBuf,PULONG pcbRetBuf);
	virtual INTERFACE_TYPE GetInterfaceType() { return m_emItfType; }
	virtual HANDLE GetMSRHandle() { return m_hMSRDev; }
	virtual void GetMSRName(CString& strDevName) { strDevName = m_strMSRName; }
	static BOOL Index2Name(ULONG ulIndex, CString& strName);
	virtual BOOL SendCommand2(BYTE* pCmdBuf,ULONG cbCmdBuf, CString &strResponse);
	virtual BOOL Send(BYTE* pCmdBuf,ULONG cbCmdBuf);
	virtual BOOL SendCommand3(BYTE* pCmdBuf,ULONG cbCmdBuf,PBYTE pRetBuf,PULONG pcbRetBuf);

	int	nReader;

protected:
	INTERFACE_TYPE	m_emItfType;
	int				m_ulIndex;
	HANDLE			m_hMSRDev;
	CString			m_strMSRName;
	PHIDP_PREPARSED_DATA m_pPreprstData;
	PHIDP_CAPS		m_pHidCaps;
	USHORT				m_VendorIDTmp;
	USHORT				m_USBHID_PIDTmp;
	USHORT				m_MAGTUSBHID_PIDTmp;
	USHORT				m_USBHIDKB_PIDTmp;
	int				m_MOIR_flg;
};

#endif // !defined(AFX_MSRITFUSBHID_H__D2FEED46_5BB6_406F_8CCB_1B070B6921CE__INCLUDED_)