// [=====================================================================]
//
//    File Name:  Utilities.cpp          Last Modified:  22/05/2006
//    Author:     P.B.Weerasinghe        First Working: 
//
//    Description:  This module wraps the DES and BASE64 
// [=====================================================================]
// [  Maintenance Record                                                 ]
// [---------------------------------------------------------------------]
//    Date         Version                  Description
//    ----------   -------        -----------------------
//    22/05/2006	  1.0.1             Code cleanup
//    26/05/2006	  1.0.2              Code cleanup
//	  09/07/2006	  1.0.6		  
// [=====================================================================]

#include "stdafx.h"
#include "DES.h"
#include "Utilities.h"

	
void GetKeyCkeckValue(const byte* pBKey,byte* pBKCV,int iLength,int iEncryption)
{
	unsigned char*   pkey;
	unsigned char*   block;
	CDES      lcDES;

	pkey = (unsigned char*)malloc((sizeof(unsigned char))*iLength);
	memcpy(pkey,pBKey,iLength);

	block = (unsigned char*)malloc((sizeof(unsigned char))*iLength);
	memset(block,0,iLength);

	if (iEncryption == ET_TDES_MS || iEncryption == ET_TDES_DUKPT || iEncryption == ET_DES_DUKPT)
	{
		if(iLength/8 == 1) lcDES.triple_des_enc(block, pkey);
		else
		{
			lcDES.triple_des_enc(block, pkey);
			lcDES.triple_des_enc(block+8, pkey);
		}
	}
	else if (iEncryption == ET_DES_MS )
	{
		if(iLength/8 == 1) lcDES.single_des_enc(block, pkey);
		else
		{
			lcDES.triple_des_enc(block, pkey);
			lcDES.triple_des_enc(block+8, pkey);
		}
	}

	memcpy(pBKCV,block,3);

	free(pkey);
	free(block);
}

void GetXORKey(const byte* pBKey1,const byte* pBKey2,byte* pBOutResult,int iLength)
{
	unsigned char*   bTemp;
	unsigned char ch1;
	unsigned char ch2;
	int loop = 0;
	bTemp = pBOutResult;
	for(loop = 0 ; loop < iLength; loop++)
	{
		ch1 = *(pBKey1 + loop);
		ch2 = *(pBKey2 + loop);
		*bTemp = (ch1)^(ch2);
		bTemp++;
	}
}

void GetInitialKSN(byte* pBUserKSN)
{
	*(pBUserKSN + 9) = 0;
	*(pBUserKSN + 8) = 0;
	*(pBUserKSN + 7) = *(pBUserKSN + 7) & 0xE0;

	byte by = *(pBUserKSN) & 0xF0;
	if( by  == 0x00 )
	{
//		*(pBUserKSN) = *(pBUserKSN) | 0xF0;
	}

}

bool GetNextKSN(byte* pBUserKSN)
{
	bool ret = false;
	if(	*(pBUserKSN + 7) >= 0xE0)
	{
		*(pBUserKSN + 7) = *(pBUserKSN + 7) & 0x1F;
		if(	*(pBUserKSN + 6) >= 0xFF)
		{
			*(pBUserKSN + 6)  = 0x00;
			if(	*(pBUserKSN + 5) >= 0xFF)
			{
				ret = false;
			}
			else
			{
				*(pBUserKSN + 5) = 	*(pBUserKSN + 5) + 1;
				ret = true;
			}
		}
		else
		{
			*(pBUserKSN + 6) = 	*(pBUserKSN + 6) + 1;
			ret = true;
		}
	}
	else
	{	
		*(pBUserKSN + 7) = *(pBUserKSN + 7) + 0x20;
		ret = true;
	}
	return ret;
}

bool GetIK(const byte* pBKSN,byte* pBDK,byte* pBIK,int Encryption)
{
	bool bReturn = false;
	CDES lcDES;

	if(Encryption == ET_TDES_DUKPT)
	{
		byte tmpKEY[8];
		byte TMP[16];
		byte toXO[] = {0xc0, 0xc0, 0xc0, 0xc0, 0x00, 0x00, 0x00, 0x00, 
					   0xc0, 0xc0, 0xc0, 0xc0, 0x00, 0x00, 0x00, 0x00};
		memcpy(tmpKEY,pBKSN,8);
		tmpKEY[7] &= 0xE0;
		lcDES.triple_des_enc(tmpKEY,pBDK);
		memcpy(pBIK,tmpKEY,8);
		GetXORKey(pBDK,toXO,TMP,16);
		memcpy(tmpKEY,pBKSN,8);
		tmpKEY[7] &= 0xE0;
		lcDES.triple_des_enc(tmpKEY,TMP);
		memcpy(pBIK + 8,tmpKEY,8);
		bReturn = true;
	}
	else if(Encryption == ET_DES_DUKPT)
	{	byte tmpKEY[8];
		memcpy(tmpKEY,pBKSN,8);
		tmpKEY[7] &= 0xE0;
		lcDES.triple_des_enc(tmpKEY,(byte*)pBDK);
		memcpy(pBIK,tmpKEY,8);
		bReturn = true;
	}
	
	return bReturn;
}