// [=====================================================================]
//
//    File Name:  Utilities.h            Last Modified:  22/05/2006
//    Author:     P.B.Weerasinghe        First Working: 
//
//    Description:  This module wraps the DES and BASE64 
// [=====================================================================]
// [  Maintenance Record                                                 ]
// [-------------------------------------------------------------------  ]
//    Date         Version        Author                   Description
//    ----------   -------         ------      --------------------------
//    22/05/2006	  1.0.1    P.B.Weerasinghe          Code cleanup
//	  09/07/2006	  1.0.6		  
// [=====================================================================]

#include <malloc.h>
#include <memory.h>

#define ET_DES_MS			0
#define ET_TDES_MS			1
#define ET_DES_DUKPT		2
#define ET_TDES_DUKPT		3

#define KT_DES_MS				1
#define KT_TDES_MS				2
#define KT_DES_DUKPT_KSN		3
#define KT_DES_DUKPT_IK			4
#define KT_TDES_DUKPT_KSN		5
#define KT_TDES_DUKPT_IK		6

#define SYMBOL   0
#define VISA     1

typedef unsigned char byte;

// pBKey = Key to get the KCV
// iLength = length of the key
// Return KCV of the Key. the length is 6
// user need to allocate pBKCV to (sizeof(unsigned char))*3
void GetKeyCkeckValue(const byte* pBKey,byte* pBKCV,int iLength,int iEncryption);

// pBKey1 = first key
// pBKey2 = second key
// iLength = iLength of the key.
// Return the XORed key the lenght is equal to iLength
// user need to allocate pBOutResult buffer to sizs of iLength
void GetXORKey(const byte* pBKey1,const byte* pBKey2,byte* pBOutResult,int iLength);

// out = the result buffer caller need to allocate the buffer.
// in = the input buffer.
// maxlen = length of the input buffer
// Return length of the return buffer.
int from64tobits(unsigned char *out, const char *in, int maxlen);

// out = the result buffer caller need to allocate the buffer.
// in = the input buffer.
// inlen = length of the input buffer
// the buffer ends with null
void to64frombits(unsigned char *out, const unsigned char *in, int inlen);

// pBUserKSN this function changes the user key to directly use in Encryption.
void GetInitialKSN(byte* pBUserKSN);

//returns the next key.
bool GetNextKSN(byte* pBUserKSN);

// returns the IK via pBIK. use need to allocate the pBIK.
bool GetIK(const byte* pBKSN,byte* pBDK,byte* pBIK,int Encryption);