/* 
* Class to access serial port
*/

#if !defined(_HEADER_SERIALCONN_)
#define _HEADER_SERIALCONN_

#define INT_RD 0	// interrupt read
#define INT_WR 1	// interrupt write.
#define CONN_INT -100	// if the operation is interrupted by user, this value returned.

class CSerial
{
public:
	CSerial();
	~CSerial();
	
	int Open(CString pszName); // format "com1/baud=9600/parity=N/stop=1/data=8"
	void Close();
	unsigned int Read(unsigned char * pBuf, unsigned int iLim, long lTimeout); // maximum 1024 bytes
	int Write(unsigned char *pbuf, unsigned int iLen, long lTimeout);
	int ReadPoint(unsigned char * pBuf, int iLim, long lTimeout);
	bool BuldBaud(int baud);
	BOOL IsOpened();

	
private:
	BOOL isOpened;
	HANDLE comm;	// handle for serial port
	HANDLE evtr;	// event for read overlapped structure
	BOOL usrInt;	// flag if user interrupt the operastion.
	char cmdsettings[128]; //"baud=9600 parity=N data=8 stop=1"; //settings for write/read cmd
	CString settings;	
	OVERLAPPED opr;	// overlapped structure for read
	OVERLAPPED opw; // overlapped structrue for write
};

#endif // _HEADER_SERIALCONN_
