// [=====================================================================]

//    Class Name:  CKeyInjectModuleDlg      Last Modified:  
//    Author: P.Rathnayake					First Working:  

//    Description:  This class holds ,process and call sub routings to carry out
//    all the tasks of the application.The folowong sub routing are functioning as specified

//	  GetKeyCheckValue - returns the check value for a given key
//	  GetXOR - returns the xored value  for given key parts
//	  SetDes - carry out the validation  and prepare the Key to be injected for DES
//	  SetTdes - carry out the validation  and prepare the Key to be injected for TDES

// [=====================================================================]
// [  Maintenance Record                                               ]
// [-------------------------------------------------------------------]
//    Date         Version        Author                   Description
//    22/05/2006	  1.0.1		  P.Rathnayake		       Code cleanup
//	  04/06/2006	  1.0.2		  P.Rathnayake			   Code cleanup
// [=====================================================================]


#include "stdafx.h"
#include "KeyInjectModule.h"
#include "KeyInjectModuleDlg.h"
#include "MSRItfUSBHID.h"
#include "DUKPT.h"
#include "DES.h"
#include "AesCipher.h"
#include "Thread.h"
#include <time.h> 
#include "serialconn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString StrInitialKey = "0123456789ABCDEFFEDCBA9876543210";
CString StrIDTECH_IIN = "629949";
CString StrKSN;
CString	StrDID;

/////////////////7.18
BYTE EncryptedData[8];
BOOL bGetChallenge = false;
BYTE MagTekKey[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
BYTE HexData[1000];
BOOL bAuthentication = false;
struct _DEVICE 
{
	CString name;
	CString port;
	int	status;
}DEVICE[256];
int count_search;
/////////////////7.18
CEvent m_Event;

const int LEN_SIXTEEN = 16;
const int LEN_THIRTYTWO	=32; 
const TCHAR CR[] = {13, 0};
BYTE WResp;

BYTE glm_nksn[10];

BOOL bIK = false;
BOOL bUpdateDisplay = false;
CString strtt;
BOOL bDecrypted = false;
unsigned long PreDecrypCounter;// for decryption, to avoid calculate cryptokey from 0 for every decrypt process
unsigned char PreDecryptKSN[10];// for decryption, to avoid calculate cryptokey from 0 for every decrypt process

CString StrHID_Data;
BYTE HID_Data[1024];
int HID_Data_Length;
CString cmd;
CString StrUSBKB;
int USBKB_Data_Length;
BYTE USBKB_Data[10];

BYTE CardDataBuffer[1000];
ULONG BufferLength = 1000;

int EncodingType;

// added by Eve
/**************************************************/
BYTE challenge[16];
BYTE KSNglb[10];
bool bActivation = false;
/**************************************************/

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUT };
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg dialog

CKeyInjectModuleDlg::CKeyInjectModuleDlg(CWnd* pParent /*=NULL*/)
: CDialog(CKeyInjectModuleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeyInjectModuleDlg)
	m_NoOfKeyPart = _T("2");
	m_Encrypt = _T("DES");
	m_strNumDevices = _T("1");
	m_imethod = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKeyInjectModuleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeyInjectModuleDlg)
	DDX_Control(pDX, IDC_COMBO_COM, m_ComboDev);
	DDX_CBString(pDX, IDC_NO_OF_KEY_PARTS, m_NoOfKeyPart);
	DDX_CBString(pDX, IDC_ENCPT, m_Encrypt);
	DDX_Text(pDX, IDC_NUM_DEVICES, m_strNumDevices);
	DDV_MaxChars(pDX, m_strNumDevices, 6);
	DDX_CBIndex(pDX, IDC_METHOD, m_imethod);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKeyInjectModuleDlg, CDialog)
//{{AFX_MSG_MAP(CKeyInjectModuleDlg)
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_CBN_EDITCHANGE(IDC_NO_OF_KEY_PARTS, OnEditchangeNoOfKeyParts)
ON_BN_CLICKED(IDC_INJECT_KEY, OnInjectKey)
ON_BN_CLICKED(IDC_INJECT, OnInject)
ON_BN_CLICKED(IDC_EXIT, OnExit)
ON_BN_CLICKED(IDC_CANCEL_DEBIT, OnCancelDebit)
ON_BN_CLICKED(IDC_SEND, OnSend)
ON_BN_CLICKED(IDC_SCRIPT, OnDecrypt)
ON_BN_CLICKED(IDC_INPUT_KEY, OnInputKey)
ON_COMMAND(ID_MENU_SetDefault, OnMENUSetDefault)
ON_COMMAND(ID_MENU_ReadConfiguration, OnMENUReadConfiguration)
ON_COMMAND(ID_MENU_ReadFirmware, OnMENUReadFirmware)
ON_COMMAND(ID_MENU_BeeperOff, OnMENUBeeperOff)
ON_COMMAND(ID_MENU_BeeperLow, OnMENUBeeperLow)
ON_COMMAND(ID_MENU_BeeperHigh, OnMENUBeeperHigh)
ON_COMMAND(ID_MENU_ReadBothDirections, OnMENUReadBothDirections)
ON_COMMAND(ID_MENU_ReadForwardDirection, OnMENUReadForwardDirection)
ON_COMMAND(ID_MENU_ReadBackwardDirection, OnMENUReadBackwardDirection)
ON_COMMAND(ID_MENU_ReadAnyTracks, OnMENUReadAnyTracks)
ON_COMMAND(ID_MENU_ReadTrack1, OnMENUReadTrack1)
ON_COMMAND(ID_MENU_ReadTrack2, OnMENUReadTrack2)
ON_COMMAND(ID_MENU_ReadTrack12, OnMENUReadTrack12)
ON_COMMAND(ID_MENU_ReadTrack3, OnMENUReadTrack3)
ON_COMMAND(ID_MENU_ReadTrack13, OnMENUReadTrack13)
ON_COMMAND(ID_MENU_ReadTrack23, OnMENUReadTrack23)
ON_COMMAND(ID_MENU_ReadAllTracks, OnMENUReadAllTracks)
ON_COMMAND(ID_MENU_SendTrackSeparator, OnMENUSendTrackSeparator)
ON_COMMAND(ID_MENU_NotSendTrackSeparator, OnMENUNotSendTrackSeparator)
ON_COMMAND(ID_MENU_SendTerminator, OnMENUSendTerminator)
ON_COMMAND(ID_MENU_NotSendTerminator, OnMENUNotSendTerminator)
ON_COMMAND(ID_MENU_About, OnMENUAbout)
ON_WM_TIMER()
ON_COMMAND(ID_MENU_TDES, OnMenuTdes)
ON_COMMAND(ID_MENU_AES, OnMenuAes)
ON_COMMAND(ID_MENU_SetPrePANClrDataID, OnMENUSetPrePANClrDataID)
ON_COMMAND(ID_MENU_SetPostPANClrDataID, OnMENUSetPostPANClrDataID)
ON_COMMAND(ID_MENU_SetMaskCharID, OnMENUSetMaskCharID)
ON_COMMAND(EnableLRCID, OnEnableLRCID)
ON_COMMAND(DisableLRCID, OnDisableLRCID)
ON_COMMAND(RawDataID, OnRawDataID)
ON_COMMAND(MSREnableID, OnMSREnableID)
ON_COMMAND(MSRDisableID, OnMSRDisableID)
ON_COMMAND(EnterBootloaderModeID, OnEnterBootloaderModeID)
ON_COMMAND(SecurityLevID, OnSecurityLevID)
ON_COMMAND(WSEErrorNotificationID, OnWSEErrorNotificationID)
ON_COMMAND(WoSEAllT2ErrorNotification, OnWoSEAllT2ErrorNotification)
ON_COMMAND(WSEPartialT2ErrorNotification, OnWSEPartialT2ErrorNotification)
ON_COMMAND(SetPreamble0123456789ID, OnSetPreamble0123456789ID)
ON_COMMAND(SetPostamble9876543210ID, OnSetPostamble9876543210ID)
ON_COMMAND(HIDMagTMode, OnHIDMagTMode)
ON_COMMAND(HIDIDTMode, OnHIDIDTMode)
ON_COMMAND(USBKBMode, OnUSBKBMode)
ON_COMMAND(ID_MENU_SetBufferMode, OnMENUSetBufferMode)
ON_COMMAND(ID_MENU_ATR, OnMenuAtr)
ON_COMMAND(ID_MENU_ReadBufferedData, OnMENUReadBufferedData)
ON_COMMAND(ID_MENU_SetPollingInterval, OnMENUSetPollingInterval)
ON_COMMAND(ID_MENU_SetArabia, OnMENUSetArabia)
ON_COMMAND(ID_MENU_SetUK, OnMENUSetUK)
ON_COMMAND(ID_MENU_SetUniversal, OnMENUSetUniversal)
ON_COMMAND(Setpollinginterval1, OnSetpollinginterval1)
ON_COMMAND(GetDeviceSN, OnGetDeviceSN)
ON_COMMAND(SetDeviceSN, OnSetDeviceSN)
ON_COMMAND(WSET2ErrornotificationAlt, OnWSET2ErrornotificationAlt)
ON_BN_CLICKED(IDC_ENTER_KEY, OnEnterKey)
ON_COMMAND(ID_MENU_SetSessionID, OnMENUSetSessionID)
ON_COMMAND(ID_MENU_ENABLEENCRYPTION, OnMenuEnableencryption)
ON_COMMAND(ID_MENU_DISABLEENCRYPTION, OnMenuDisableencryption)
	ON_BN_CLICKED(IDC_ACTAUTH, OnActivateAuthentication)
	ON_BN_CLICKED(IDC_ACTRPLY, OnActivateChallengeReply)
	ON_BN_CLICKED(IDC_DEACTRPLY, OnDeactivateChallengeReply)
	ON_BN_CLICKED(IDC_STATUS, OnGetReaderStatus)
	ON_COMMAND(ID_MENU_NewEncryptionFormat, OnMENUNewEncryptionFormat)
	ON_COMMAND(ID_MENU_OldEncryptionFormat, OnMENUOldEncryptionFormat)
	ON_COMMAND(ID_MENU_ForceEncryptAllTracks, OnMENUForceEncryptAllTracks)
	ON_COMMAND(ID_MENU_Clear, OnMENUClear)
	ON_COMMAND(GetKSN, OnGetKSN)
	ON_COMMAND(ID_MENU_DisEncryp, OnMENUDisEncryp)
	ON_COMMAND(ID_MENU_SETFIXED_KEY, OnMenuSetfixedKey)
	ON_COMMAND(ID_MENU_SETDUPKT, OnMenuSetdupkt)
	ON_COMMAND(ID_MENU_CHAllenge, OnMENUCHAllenge)
	ON_COMMAND(ID_MENU_AUTHENT, OnMenuAuthent)
	ON_COMMAND(ID_MENU_LOADKEY, OnMenuLoadkey)
	ON_COMMAND(ID_MENU_Bluetooth, OnMENUBluetooth)
	ON_BN_CLICKED(IDC_BUTTON_REFRESH, OnButtonRefresh)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	ON_COMMAND(ID_MENU_Clear2, OnMENUClear2)
ON_BN_CLICKED(IDC_CANCEL, OnCancel)
//	ON_COMMAND(ID_MENU_BTClose, OnMENUBTClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg message handlers

BOOL CKeyInjectModuleDlg::OnInitDialog()
{
	
	CDialog::OnInitDialog();
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	GetDlgItem(IDC_EDIT1)->SetWindowText("60");
	SetDlgItemText(IDC_NO_OF_KEY_PARTS,"2");
//	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_INJECT_KEY)->ShowWindow(FALSE);
	((CComboBox*)GetDlgItem(IDC_ENCPT))->SetCurSel(1);
	//SetDlgItemText(IDC_ENCPT,"TDES");
	SetDlgItemText(IDC_METHOD,"DUKPT");
	
	GetDlgItem(IDC_CANCEL)->ShowWindow(FALSE);
	GetDlgItem(IDC_CANCEL_DEBIT)->ShowWindow(FALSE);
	//	GetDlgItem(IDC_COMMAND)->SetFocus();
	
	m_pMasterKey = (byte*)malloc(sizeof(byte) * 16);
	m_pMasterKcv = (byte*)malloc(sizeof(byte) * 3);
	
	m_pKsn = (byte*)malloc(sizeof(byte) * 10);	
	m_pKsnKcv = (byte*)malloc(sizeof(byte) * 3);
	
	m_pBdk = (byte*)malloc(sizeof(byte) * 16);
	m_pBdkKcv = (byte*)malloc(sizeof(byte) * 3);
	
	///////////////////////////////////////
	count_search=0;
	IsOpen = FALSE;
	IsSend = FALSE;
	IsCardSend = FALSE;
	InitializeCriticalSection(CS);
	/////////////////////////////////////////

	// Add the Menu 
	m_menu.LoadMenu(IDR_MENU);
	SetMenu(&m_menu);
	
	// Timer interval = 10ms
	m_Timer = SetTimer(1, 10, 0);  
	
	// Decryption
	bDecryptMode = 0; // No Encryption
	HIDMode = 0; // ID Tech USB HID
	
	// Thread for reading track data
	CThread* pThread;
    pThread = new CThread();
    pThread->CreateThread();
    pThread->PostThreadMessage(WM_THREADMESSAGE,NULL,NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CKeyInjectModuleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKeyInjectModuleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CKeyInjectModuleDlg::SetToHex(const byte *inBuff,  byte *outBuff,int iLen)
{
	
	int j=0;
	unsigned char* tempCh2 = NULL;
	tempCh2 = (unsigned char*)malloc(sizeof(BYTE)*3);
	for (int  i = 0 ; i < iLen/2 ;i++) 
	{
		memcpy(tempCh2,inBuff+i*2,2);
		*(tempCh2+2) = 0;
		j = static_cast<int>(strtol((char *)tempCh2,NULL, 16));
		*(outBuff + i)  = j;
	}
	free(tempCh2);
	
	
}

void CKeyInjectModuleDlg::OnEditchangeNoOfKeyParts() 
{
	//empty body	
}

void CKeyInjectModuleDlg::FreeMem(unsigned char *pCh)
{
	if(pCh !=NULL)
		free(pCh);
	pCh = NULL;
}

void CKeyInjectModuleDlg::CallInjector(int iencryption, int ikeyParts)
{
	
	switch(iencryption)
	{
	case ET_DES_MS:
		m_iCurrentOperation = ET_DES_MS;
		MasterDES(ikeyParts);
		break;
	case ET_TDES_MS:
		m_iCurrentOperation = ET_TDES_MS;
		MasterTDES (ikeyParts);
		break;
	case ET_DES_DUKPT:
		m_iCurrentOperation = ET_DES_DUKPT;
		DUKPT_DES (ikeyParts);
		break;
	case ET_TDES_DUKPT:
		m_iCurrentOperation = ET_TDES_DUKPT;
		DUKPT_TDES (ikeyParts);
		break;
	};
}

int CKeyInjectModuleDlg::Getkey(int ilen , byte *pRtrn)
{
	int nResponse;
	int cTemp;
	int len ;
	CString strKey;
	CString strKeyConfirm;
	CString strTemp;
	int TextLen=0;
	CString strTextLen;
	byte* pBTempBuff = NULL;
	
	UpdateData(TRUE);
	
	TextLen = ilen;
	strTextLen.Format("%i",TextLen);
	
	m_KetRtrvr.m_iKeyLen = TextLen;
	
	nResponse =m_KetRtrvr.DoModal();
	if (nResponse == IDOK)
	{
		
		strKey = m_KetRtrvr.m_strKey;
		strKeyConfirm = m_KetRtrvr.m_strKerConfirm;
		if(strKey.Compare(strKeyConfirm) !=0)
		{
			
			m_KetRtrvr.m_strKey.Empty();
			m_KetRtrvr.m_strKerConfirm.Empty();
			AfxMessageBox("Key Mismatch, Please Re-Enter");
			return 1; // key Mismatch
			
		}
		if(strKey.GetLength() < TextLen || strKeyConfirm.GetLength() < TextLen   )
		{
			m_KetRtrvr.m_strKey.Empty();
			m_KetRtrvr.m_strKerConfirm.Empty();		
			AfxMessageBox("Length of the key should be "+strTextLen);
			return 2; // length of the key should be 32
		}
		
		len = strKey.GetLength ();
		strKey.MakeUpper ();
		
		for(int loop = 0; loop<len;loop++)
		{
			cTemp = (int) strKey.GetAt(loop);
			if(!(((cTemp >= 0x30)&&(cTemp <= 0x39)) ||((cTemp >= 0x41)&&(cTemp <= 0x46))))
			{
				m_KetRtrvr.m_strKey.Empty();
				m_KetRtrvr.m_strKerConfirm.Empty();		
				AfxMessageBox ("Invalid Key Input,Please Re-Enter");
				return 2;
			}
		}
		
		
		m_KetRtrvr.m_strKey.Empty();
		m_KetRtrvr.m_strKerConfirm.Empty();
		pBTempBuff = (byte*)malloc(sizeof(byte)*ilen);
		memcpy(pBTempBuff,strKey.GetBuffer(strKey.GetLength()),strKey.GetLength());
		strKey.ReleaseBuffer();
		SetToHex(pBTempBuff,pRtrn,ilen);
		free(pBTempBuff);
		
	}
	else if(nResponse == IDCANCEL)
	{
		m_KetRtrvr.m_strKey.Empty();
		m_KetRtrvr.m_strKerConfirm.Empty();
		AfxMessageBox("Key entry canceled");
		return 3;// Key entry canceled;
		
	}
	
	return 0;
}

void CKeyInjectModuleDlg::MakeVisibleDebitKey()
{
//	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(TRUE);
	GetDlgItem(IDC_INJECT_KEY)->ShowWindow(TRUE);
	GetDlgItem(IDC_INPUT_KEY)->ShowWindow(FALSE);
//	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(TRUE);
	
	GetDlgItem(IDC_ENTER_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_IIN_LBL)->EnableWindow(FALSE);
	GetDlgItem(IDC_IIN)->EnableWindow(FALSE);
	GetDlgItem(IDC_DID_LBL)->EnableWindow(FALSE);
	GetDlgItem(IDC_DID)->EnableWindow(FALSE);
	GetDlgItem(IDC_CID_LBL)->EnableWindow(FALSE);			
	GetDlgItem(IDC_CID)->EnableWindow(FALSE);
	GetDlgItem(IDC_GID_LBL)->EnableWindow(FALSE);
	GetDlgItem(IDC_GID)->EnableWindow(FALSE);
	GetDlgItem(IDC_OK)->EnableWindow(FALSE);
	
	GetDlgItem(IDC_ENCPT)->EnableWindow(FALSE);
	GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(FALSE);
	GetDlgItem(IDC_METHOD)->EnableWindow(FALSE);
	GetDlgItem(IDC_METHOD_LBL)->EnableWindow(FALSE);
	GetDlgItem(IDC_CANCEL)->ShowWindow(FALSE);
	GetDlgItem(IDC_EXIT)->ShowWindow(FALSE);
	
	GetDlgItem(IDC_CANCEL_DEBIT)->ShowWindow(TRUE);
	GetDlgItem(IDC_NUM_DEVICES)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_NUM_DEVICES_LBL)->ShowWindow(SW_HIDE);
	
}

int CKeyInjectModuleDlg::DisplayMsg(CString DisMsg, CString DisVal, CString Cap, UINT type)
{
	
	int iResponse;
	iResponse = MessageBox(DisMsg+DisVal,Cap,type);
	return iResponse;
}

CString CKeyInjectModuleDlg::FormatHexToStr(byte *pBKCV)
{
	CString strCheckVal;
	CString strTemp;
	for(int k=0;k<3;k++)
	{
		strTemp.Format("%.2x",*(pBKCV+k));
		strCheckVal = strCheckVal + strTemp;
	}
	strCheckVal.MakeUpper();
	return strCheckVal;
}

void CKeyInjectModuleDlg::DUKPT_DES(int keyParts)
{
	DUKPT_TDES(keyParts);
}

void CKeyInjectModuleDlg::DUKPT_TDES(int keyParts)
{
	CString strKey;
	CString strKeyConfirm;
	CString strTemp;
	CString strCheckVal;
	char cArray[3] ;
	
	m_KetRtrvr.m_sCaption = "Key Serial Number";
	m_KetRtrvr.m_strLabel = "KSN";
	m_KetRtrvr.m_cPasswordChar = 0;
	m_KetRtrvr.m_strCaption = "";
	
	int iEncpt=0;
	int i=0,j;
	int iRspnsCheckVal =0;
	int iReturnStatus=0;
	
	BOOL bCancel = FALSE;
	BOOL bExitMethod = FALSE;
	
	byte* ks =NULL;
	byte* keyOut = NULL;
	byte* bUserKey =NULL;
	byte* pBKCV = NULL;
	byte* pKSN = NULL;
	byte* pKCV_KSN = NULL;
	
	pKSN =(byte*)malloc(sizeof(byte) * 8);
	pKCV_KSN = (byte*)malloc(sizeof(byte) * 3);
	bUserKey =(byte*)malloc(sizeof(byte) * 16);
	pBKCV = (byte*) malloc(sizeof(byte)*3);
	keyOut = (byte*)malloc(sizeof(byte)* 16);
	ks = (byte*)malloc(sizeof(byte)* 16);
	
	for(j=0;j<1;j++)
	{
		byte* pKSN1 = NULL;
		pKSN1 =(byte*)malloc(sizeof(byte) * 16);
		
		memcpy(pKSN1,StrKSN.GetBuffer(StrKSN.GetLength()),StrKSN.GetLength());
		SetToHex(pKSN1,pKSN,16);
		
		free(pKSN1);
		
		
		if( (iReturnStatus == 2) || (iReturnStatus == 1) )
		{
			--j;
			continue;
		}
		else if(iReturnStatus == 3)
		{
			bExitMethod = TRUE;
			GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
			GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
			
			GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
			GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
			
			
			break;	
		}
	}
	
	if(!bExitMethod)
	{
		m_KetRtrvr.m_sCaption = "Base Derivation Key";
		m_KetRtrvr.m_strLabel = "Key Part #";
		m_KetRtrvr.m_cPasswordChar = '*';
		
		GetKeyCkeckValue(pKSN,pKCV_KSN,8,ET_DES_MS);	// KSN encrypts using des.
		
		memcpy(m_pKsn,pKSN,8);
		memcpy(m_pKsnKcv,pKCV_KSN,3);
		
		
		for(i=0;i< keyParts;i++)
		{
			
			itoa(i+1,cArray,10);
			m_KetRtrvr.m_strCaption = cArray;
			
			iReturnStatus = Getkey(LEN_THIRTYTWO,bUserKey);
			if(!iReturnStatus)
			{
				
				GetKeyCkeckValue(bUserKey,pBKCV,16,ET_TDES_DUKPT);
				strCheckVal = FormatHexToStr(pBKCV);
				iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Key Check Value",MB_OKCANCEL);
				strCheckVal.Empty();
				if(iRspnsCheckVal ==2)
				{
					--i;
					continue;
				}
				else if (iRspnsCheckVal ==1)
				{
					if(i==0)
						memset(ks,0,16);
					GetXORKey(ks,bUserKey,keyOut,16);
					memcpy(ks,keyOut,16);
					memset(keyOut,0,16);
					
				}
			}
			else if(iReturnStatus == 1)
			{
				--i;
				continue;
			}
			else if(iReturnStatus == 2)
			{
				--i;
				continue;
			}
			else if(iReturnStatus == 3)
			{
				bCancel = TRUE;
				GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
				GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
				
				
				GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
				GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
				break;	
			}
			
			
		} // end of main for loop
		
		if(!bCancel)
		{
			
			iRspnsCheckVal =0;
			
			GetKeyCkeckValue(ks,pBKCV,16,ET_DES_DUKPT);
			strCheckVal.Empty();
			strCheckVal = FormatHexToStr(pBKCV);
			iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Generated Key Check Value",MB_OKCANCEL);
			
			if(iRspnsCheckVal ==2)
			{
			}
			else if (iRspnsCheckVal ==1)
			{
				memcpy(m_pBdk,ks,16);
				memcpy(m_pBdkKcv,pBKCV,3);
				
				MakeVisibleDebitKey();
			}
		}
		
	}//bExitMethod
	
	free(pKCV_KSN);
	free(pKSN);
	free(bUserKey);
	free(pBKCV);
	free(keyOut);
	free(ks);
}


void CKeyInjectModuleDlg::MasterDES(int keyParts)
{
	CString strKey;
	CString strKeyConfirm;
	CString strTemp;
	CString strCheckVal;
	char cArray[3] ;
	
	m_KetRtrvr.m_sCaption = "Master Key";
	m_KetRtrvr.m_strLabel = "Key Part #";
	m_KetRtrvr.m_cPasswordChar = '*';
	
	int iEncpt=0;
	int i=0;
	int iRspnsCheckVal =0;
	int iReturnStatus=0;
	
	BOOL bCancel = FALSE;
	
	
	byte * pBKCV = (byte*) malloc(sizeof(byte)*3);
	byte * keyOut = (byte*)malloc(sizeof(byte) *8);
	byte * ks = (byte*)malloc(sizeof(byte) * 8);
	byte * bUserKey =(byte*)malloc(sizeof(byte) *8);
	
	for(i=0;i< keyParts;i++)
	{
		
		itoa(i+1,cArray,10);
		m_KetRtrvr.m_strCaption = cArray;
		
		iReturnStatus = Getkey(16,bUserKey);
		
		if(!iReturnStatus)
		{
			GetKeyCkeckValue(bUserKey,pBKCV,8,ET_DES_MS);
			strCheckVal = FormatHexToStr(pBKCV);
			iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Key Check Value",MB_OKCANCEL);
			strCheckVal.Empty();
			if(iRspnsCheckVal ==2)
			{
				--i;
				continue;
			}
			else if (iRspnsCheckVal ==1)
			{
				if(i==0)
					memset(ks,0,8);
				GetXORKey(ks,bUserKey,keyOut, 8);
				memcpy(ks,keyOut,8);
				memset(keyOut,0,8);
				
			}
		}
		else if(iReturnStatus == 1)
		{
			--i;
			continue;
		}
		else if(iReturnStatus == 2)
		{
			--i;
			continue;
		}
		else if(iReturnStatus == 3)
		{
			bCancel = TRUE;
			GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
			GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
			
			GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
			GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
			break;	
		}
		
		
	} // end of main for loop
	
    if(!bCancel)
	{
		
		iRspnsCheckVal =0;
		
		GetKeyCkeckValue(ks,pBKCV,8,ET_DES_MS);
		strCheckVal.Empty();
		strCheckVal = FormatHexToStr(pBKCV);
		iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Generated Key Check Value",MB_OKCANCEL);
		
		if(iRspnsCheckVal ==2)
		{
		}
		else if (iRspnsCheckVal ==1)
		{
			memcpy(m_pMasterKey,ks,8); 
			memcpy(m_pMasterKcv,pBKCV,3);
			
			MakeVisibleDebitKey();
		}
	}
	
	free(ks);
	free(bUserKey);
	free(keyOut);
	free(pBKCV);
	
}

void CKeyInjectModuleDlg::MasterTDES(int keyParts)
{
	CString strKey;
	CString strKeyConfirm;
	CString strTemp;
	CString strCheckVal;
	char cArray[3] ;
	
	m_KetRtrvr.m_sCaption = "Master Key";
	m_KetRtrvr.m_strLabel = "Key Part #";
	m_KetRtrvr.m_cPasswordChar = '*';
	
	int iEncpt=0;
	int i=0;
	int iRspnsCheckVal =0;
	int iReturnStatus=0;
	
	BOOL bCancel = FALSE;
	
	byte * ks =NULL;
	byte * keyOut = NULL;
	byte * bUserKey =NULL;
	byte * pBKCV = NULL;
	
	pBKCV = (byte*) malloc(sizeof(byte*)*3);
	keyOut = (byte*)malloc(sizeof(byte)* 16);
	ks = (byte*)malloc(sizeof(byte)* 16);
	bUserKey =(byte*)malloc(sizeof(byte) * 16);
	
	
	for(i=0;i< keyParts;i++)
	{
		
		itoa(i+1,cArray,10);
		m_KetRtrvr.m_strCaption = cArray;
		
		iReturnStatus = Getkey(LEN_THIRTYTWO,bUserKey);
		if(!iReturnStatus)
		{
			GetKeyCkeckValue(bUserKey,pBKCV,16,ET_TDES_MS);
			strCheckVal = FormatHexToStr(pBKCV);
			iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Key Check Value",MB_OKCANCEL);
			strCheckVal.Empty();
			if(iRspnsCheckVal ==2)
			{
				--i;
				continue;
			}
			else if (iRspnsCheckVal ==1)
			{
				if(i==0)
					memset(ks,0,16);
				
				GetXORKey(ks,bUserKey,keyOut,16);
				
				memcpy(ks,keyOut,16);
				memset(keyOut,0,16);
				
			}
		}
		else if(iReturnStatus == 1)
		{
			--i;
			continue;
		}
		else if(iReturnStatus == 2)
		{
			--i;
			continue;
		}
		else if(iReturnStatus == 3)
		{
			bCancel = TRUE;
			GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
			GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
			
			GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
			GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
			
			break;	
		}
		
		
	} // end of main for loop
	
    if(!bCancel)
	{
		
		iRspnsCheckVal =0;
		
		GetKeyCkeckValue(ks,pBKCV,16,ET_TDES_MS);
		strCheckVal.Empty();
		strCheckVal = FormatHexToStr(pBKCV);
		iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Generated Key Check Value",MB_OKCANCEL);
		
		if(iRspnsCheckVal ==2)
		{
		}
		else if (iRspnsCheckVal ==1)
		{
			
			memcpy(m_pMasterKey,ks,16);
			memcpy(m_pMasterKcv,pBKCV,3);
			
			MakeVisibleDebitKey();
		}
	}
	
	free(pBKCV);
	free(ks);
	free(bUserKey);
	free(keyOut);
	
}


bool CKeyInjectModuleDlg::SendToDevice(int iProtocol, int iKeyType,bool bIsData, byte *bpRawKey ,byte* pBKCV,int *ipLength)
{
	byte* bInjectData = NULL;
	bool bRetVal = false;
	m_Event.ResetEvent();
	CString StrResponse;
	ULONG	BufferLength = 2048;

	//Open bluetooth ??
	if (IsOpen==1)
	{
		// Inject KSN
		if((iKeyType == KT_DES_DUKPT_KSN) ||  (iKeyType == KT_TDES_DUKPT_KSN))
		{
			int alen = (*ipLength)*2+27+1;
			bInjectData  =	(byte*) malloc(sizeof(byte)*(alen));
			m_protocolMgr.getKSNData(iProtocol,iKeyType,bpRawKey,bInjectData,ipLength);
			
			//Show Status
			StrResponse = "Injecting KSN.....\r\nPlease Wait!";
			GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
			Invalidate();
			UpdateWindow();
			
			Sleep(500);
			// Load KSN
			SendBluetoothCommand(bInjectData,*ipLength);
		//	Device.Write((unsigned char*)bInjectData,(unsigned long) *ipLength,2000);
		//	Sleep(2000);
		//	ReadHex();
			
			if (( HexData[0] == 6) && (m_protocolMgr.validateInject(SYMBOL,HexData,pBKCV) == 0) )	
			{
				bRetVal = true;
			}
			
			FreeMem(bInjectData);
			return bRetVal;
		}
		
		// Load Key
		else if (bIsData)	
		{
			//Show Status
			StrResponse = "Injecting Key.....\r\nPlease Wait!";
			GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
			Invalidate();
			UpdateWindow();
			
			bInjectData  =	(byte*) malloc(sizeof(byte)*(*(ipLength)*2+27+1));
			m_protocolMgr.getInjectData(iProtocol,iKeyType,bpRawKey,bInjectData,ipLength);
			
			Sleep(500);	
			SendBluetoothCommand(bInjectData,*ipLength);
		//	Device.Write((unsigned char*)bInjectData,(unsigned long) *ipLength,2000);
		//	Sleep(2000);
		//	ReadHex();
			
			if (( HexData[0] == 6) && (m_protocolMgr.validateInject(SYMBOL,HexData,pBKCV) == 0) )	
			{
				StrResponse += "\r\nKey Injection Success!";
				GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
				Invalidate();
				UpdateWindow();
				bRetVal = true;
			}
			else
			{					
				StrResponse += "\r\nFail to Inject Key! Response not match!";
				GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
				Invalidate();
				UpdateWindow();
				bRetVal = false;
			}
			
			FreeMem(bInjectData);
			return bRetVal;
		}
		
		else // Enter Key Loading Mode
		{					
			//Enter Key Loading Mode
			StrResponse = "Entering Key Loading Mode.....\r\nPlease Wait!";
			GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
			Invalidate();
			UpdateWindow();
			
			// Get Key Status
			bInjectData =(byte*) malloc(sizeof(byte)*((*ipLength)+15+1));
			m_protocolMgr.getStatusData(bInjectData,iProtocol,ipLength);
			
			//Check Key Status
			StrResponse = "Checking Key Status.....\r\nPlease Wait!";
			GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
			Invalidate();
			UpdateWindow();
			
			SendBluetoothCommand(bInjectData,*ipLength);
//			Device.Write((unsigned char*)bInjectData,(unsigned long) *ipLength,2000);
//			Sleep(2000);			
//			ReadHex();
			
			if (( HexData[0] == 6)&&(m_protocolMgr.validateStatus(SYMBOL,HexData)  == 0) )
			{
				bRetVal = true;
			}
			
			FreeMem(bInjectData);
			return bRetVal;				
		}
	}
	//KB,HID,,,,,, 
	else
	{
		INTERFACE_TYPE emMyItfType; 
		INTERFACE_TYPE emMyItfType2;
		CString strDevName;
		ULONG emMyItfType1; 
		int		m_ulDevIndex = 0;
		emMyItfType1 = '1';
		emMyItfType2 = ITF_TYPE_USB_HID;
		CMSRItfUSBHID	MSR(emMyItfType2);
		BYTE BufferTmp[2048];
	
		// Inject KSN
		if((iKeyType == KT_DES_DUKPT_KSN) ||  (iKeyType == KT_TDES_DUKPT_KSN))
		{
			int alen = (*ipLength)*2+27+1;
			bInjectData  =	(byte*) malloc(sizeof(byte)*(alen));
			m_protocolMgr.getKSNData(iProtocol,iKeyType,bpRawKey,bInjectData,ipLength);
			// USB HID Interface
			for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
			{
				if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
				{
					if(emMyItfType != emMyItfType2)			
						continue;
					else
					{
						if(MSR.OpenMSRDevice(m_ulDevIndex))
						{	//Show Status
							StrResponse = "Injecting KSN.....\r\nPlease Wait!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							Sleep(500);
							// Load KSN
							MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);
						}
					}
				}
			}
			// USB KB Interface
			if(m_ulDevIndex >= 10)
			{
				emMyItfType2 = ITF_TYPE_USB_HID_KB;	
				CMSRItfUSBHID	MSR(emMyItfType2);
				for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
				{
					if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
					{
						if(emMyItfType != emMyItfType2)
							continue;
						else
						{
							if(MSR.OpenMSRDevice(m_ulDevIndex))
							{	//Show Status
								StrResponse = "Injecting KSN.....\r\nPlease Wait!";
								GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
								Invalidate();
								UpdateWindow();
								Sleep(500);
								// Load KSN
								MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);
							}
						}
					}
				}		
			}			
			if(BufferLength)
			{
				if (( BufferTmp[0] == 6) && (m_protocolMgr.validateInject(SYMBOL,BufferTmp,pBKCV) == 0) )	
				{
					bRetVal = true;
					Sleep(100);
				}
			}
			else
			{
				StrResponse += "\r\nNo Response from reader!\r\nFail to Inject KSN!";
				GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
				Invalidate();
				UpdateWindow();
				bRetVal = false;
			}
			FreeMem(bInjectData);
			return bRetVal;
		}
		// Load Key
		else if (bIsData)	
		{	// USB HID Interface
			for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
			{
				if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
				{
					if(emMyItfType != emMyItfType2)			
						continue;
					else
					{
						MSR.OpenMSRDevice(m_ulDevIndex);
						//Show Status
						StrResponse = "Injecting Key.....\r\nPlease Wait!";
						GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
						Invalidate();
						UpdateWindow();
						bInjectData  =	(byte*) malloc(sizeof(byte)*(*(ipLength)*2+27+1));
						m_protocolMgr.getInjectData(iProtocol,iKeyType,bpRawKey,bInjectData,ipLength);					
						Sleep(500);
						MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);
						if(BufferLength)
						{
							if ((BufferTmp[0] == 6) && (m_protocolMgr.validateInject(SYMBOL,BufferTmp,pBKCV) == 0) )
							{
								StrResponse += "\r\nKey Injection Success!";
								GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
								Invalidate();
								UpdateWindow();
								bRetVal = true;
							}
							else
							{					
								StrResponse += "\r\nFail to Inject Key!";
								GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
								Invalidate();
								UpdateWindow();
								bRetVal = false;
							}					
						}
						else
						{
							StrResponse += "\r\nNo Response from reader!\r\nFail to Inject Key!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							bRetVal = false;
						}
						/*
						if (MSR.nReader == 1) // SecureMag Reader
						{
							// Exit Key Loading Mode
							BYTE datapool[8];
							datapool[0] = 0x55;
							datapool[1] = 0x01;
							datapool[2] = 0x06;
							datapool[3] = 0x08;
							datapool[4] = 0x01;
							datapool[5] = 0x01;
							datapool[6] = 0x5A;
							int outLength = 7;
							Sleep(500);
							MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
						}				
						*/
						FreeMem(bInjectData);
						return bRetVal;
					}
				}
			}
			// USB KB Interface
			if(m_ulDevIndex >= 10)
			{
				emMyItfType2 = ITF_TYPE_USB_HID_KB;
				CMSRItfUSBHID	MSR(emMyItfType2);
				for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
				{
					if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
					{
						if(emMyItfType != emMyItfType2)
							continue;
						else
						{
							MSR.OpenMSRDevice(m_ulDevIndex);
							//Show Status
							StrResponse = "Injecting Key.....\r\nPlease Wait!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							bInjectData  =	(byte*) malloc(sizeof(byte)*(*(ipLength)*2+27+1));
							m_protocolMgr.getInjectData(iProtocol,iKeyType,bpRawKey,bInjectData,ipLength);						
							Sleep(500);
							MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);						
							if(BufferLength)
							{
								if ((BufferTmp[0] == 6) && (m_protocolMgr.validateInject(SYMBOL,BufferTmp,pBKCV) == 0) )
								{
									StrResponse += "\r\nKey Injection Success!";
									GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
									Invalidate();
									UpdateWindow();
									bRetVal = true;
								}
								else
								{					
									StrResponse += "\r\nFail to Inject Key!";
									GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
									Invalidate();
									UpdateWindow();
									bRetVal = false;
								}					
							}
							else
							{
								StrResponse += "\r\nNo Response from reader!\r\nFail to Inject Key!";
								GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
								Invalidate();
								UpdateWindow();
								bRetVal = false;
							}
							/*
							if (MSR.nReader == 1) // SecureMag Reader
							{
								// Exit Key Loading Mode
								BYTE datapool[8];
								datapool[0] = 0x55;
								datapool[1] = 0x01;
								datapool[2] = 0x06;
								datapool[3] = 0x08;
								datapool[4] = 0x01;
								datapool[5] = 0x01;
								datapool[6] = 0x5A;
								int outLength = 7;
								Sleep(200);
								MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
							}
							*/
							FreeMem(bInjectData);
							return bRetVal;
						}
					}
				}		
			}
		}
		else // Enter Key Loading Mode
		{
			// USB HID Interface
			for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
			{
				if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
				{
					if(emMyItfType != emMyItfType2)			
						continue;
					else
					{
						MSR.OpenMSRDevice(m_ulDevIndex);
						/*
						if (MSR.nReader == 1) // SecureMag Reader
						{
							//Enter Key Loading Mode
							StrResponse = "Entering Key Loading Mode.....\r\nPlease Wait!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							Sleep(100);
							BYTE datapool[8];
							datapool[0] = 0x55;
							datapool[1] = 0x01;
							datapool[2] = 0x06;
							datapool[3] = 0x08;
							datapool[4] = 0x09;
							datapool[5] = 0x01;
							datapool[6] = 0x5A;
							int outLength = 7;
							MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);	
						
						}
							*/
						// Get Key Status
						bInjectData =(byte*) malloc(sizeof(byte)*((*ipLength)+15+1));
						m_protocolMgr.getStatusData(bInjectData,iProtocol,ipLength);					
						//Check Key Status
						StrResponse = "Checking Key Status.....\r\nPlease Wait!";
						GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
						Invalidate();
						UpdateWindow();
						MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);									
						if(BufferLength)
						{
							if ( (BufferTmp[0] == 6) && (m_protocolMgr.validateStatus(SYMBOL,BufferTmp)  == 0) )
							{
								bRetVal = true;
								Sleep(100);
							}
						}
						else
						{
							StrResponse += "\r\nNo Response from reader!\r\nFail to Check Key Status!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							bRetVal = false;
						}
						bRetVal = true;						
					}
					FreeMem(bInjectData);
					return bRetVal;		
				}
			}	
			// USB KB Interface
			if(m_ulDevIndex >= 10)
			{
				emMyItfType2 = ITF_TYPE_USB_HID_KB;
				CMSRItfUSBHID	MSR(emMyItfType2);
				for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
				{
					if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
					{
						if(emMyItfType != emMyItfType2)
							continue;
						else
						{
							MSR.OpenMSRDevice(m_ulDevIndex);
							/*
							if (MSR.nReader == 1) // SecureMag Reader
							{
								//Enter Key Loading Mode
								StrResponse = "Entering Key Loading Mode.....\r\nPlease Wait!";
								GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
								Invalidate();
								UpdateWindow();
								Sleep(100);
								BYTE datapool[8];
								datapool[0] = 0x55;
								datapool[1] = 0x01;
								datapool[2] = 0x06;
								datapool[3] = 0x08;
								datapool[4] = 0x09;
								datapool[5] = 0x01;
								datapool[6] = 0x5A;
								int outLength = 7;
								MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);	
							}
							*/
							// Get Key Status
							bInjectData =(byte*) malloc(sizeof(byte)*((*ipLength)+15+1));
							m_protocolMgr.getStatusData(bInjectData,iProtocol,ipLength);						
							//Show Status
							StrResponse = "Checking Key Status.....\r\nPlease Wait!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);											
							if(BufferLength)
							{
								if ( (BufferTmp[0] == 6) && (m_protocolMgr.validateStatus(SYMBOL,BufferTmp)  == 0) )
								{
									bRetVal = true;
									Sleep(100);
								}
							}
							else
							{
								StrResponse += "\r\nNo Response from reader!\r\nFail to Check Key Status!";
								GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
								Invalidate();
								UpdateWindow();
								bRetVal = false;
							}
						}
						FreeMem(bInjectData);
						return bRetVal;				
					}
				}		
			}
		}
		MSR.CloseMSRDevice();
	}

	return bRetVal;	
}

void CKeyInjectModuleDlg::InitDlg()
{
//	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_INJECT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_INPUT_KEY)->ShowWindow(FALSE);
	
	GetDlgItem(IDC_ABOUTKEY)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_NO_OF_KEY_PARTS)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_KEYPART)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_OK)->EnableWindow(SW_NORMAL);
	GetDlgItem(IDC_ENCPT)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_ENCPT_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_METHOD)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_METHOD_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_EXIT)->ShowWindow(TRUE);
	GetDlgItem(IDC_CANCEL)->ShowWindow(FALSE);
	GetDlgItem(IDC_CANCEL_DEBIT)->ShowWindow(FALSE);
	
	GetDlgItem(IDC_NUM_DEVICES)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_NUM_DEVICES_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
	GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
	GetDlgItem(IDC_ALGORITHM)->ShowWindow(TRUE);
	
	GetDlgItem(IDC_ENTER_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_KSN_GROUP)->ShowWindow(FALSE);
	GetDlgItem(IDC_IIN_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_IIN)->ShowWindow(FALSE);
	GetDlgItem(IDC_DID_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_DID)->ShowWindow(FALSE);
	GetDlgItem(IDC_CID_LBL)->ShowWindow(FALSE);			
	GetDlgItem(IDC_CID)->ShowWindow(FALSE);
	GetDlgItem(IDC_GID_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_GID)->ShowWindow(FALSE);
	
}

//make the ASCII format Hex command to real hex commands.
//pcbCmd IN: the size of bysCmd buffer, OUT: the real bytes counts of the command
BOOL CKeyInjectModuleDlg::MakeCommand(CString& strCmd, PBYTE bysCmd, int* pcbCmd)
{	
	CString strTemp;
	BYTE byChkSum = 0;
	int nCount=0, nBufSize=0, i;
	
	if(bysCmd == NULL || *pcbCmd == NULL)
		return FALSE;
	nBufSize = *pcbCmd;
	
	strCmd.MakeUpper(); //Make the command upper case
	
	for (i=0; i<nBufSize/2; i++)
	{
		strTemp = strCmd.Left(2);
		bysCmd[i] = Char2Hex(strTemp[0]) << 4 | Char2Hex(strTemp[1]);		
		strCmd = strCmd.Right(nBufSize-2*i-2);
		nCount++;
	}
	
	*pcbCmd = nCount;
	
	return TRUE; 
}

// Get the Hex byte for matching char
BYTE CKeyInjectModuleDlg::Char2Hex(char ch) 
{
	if( ch >= '0' && ch <= '9')
		return BYTE(ch-'0');
	
	if(ch >= 'A' && ch <= 'F')
		return BYTE(ch-'A'+10);
	
	if(ch >= 'a' && ch <= 'f')
		return BYTE(ch-'a'+10);
	
	return 0;
}

byte CKeyInjectModuleDlg::asctohex(byte m, byte n)
{
	if(m>47 && m<58)
		m -= 48;
	else if (m>64 && m<91)
		m -= 55;
	else m -= 87;
	
	if(n>47 && n<58)
		n -= 48;
	else if (n>64 && n<91)
		n -= 55;
	else n -= 87;
	
	return (16*m+n);
	
}

byte CKeyInjectModuleDlg::asctodec(byte m, byte n)
{
	if(m>47 && m<58)
		m -= 48;
	else if (m>64 && m<91)
		m -= 55;
	else m -= 87;
	
	if(n>47 && n<58)
		n -= 48;
	else if (n>64 && n<91)
		n -= 55;
	else n -= 87;
	
	return (10*m+n);
	
}

//function:  if you click this button, it will pop up a input dialog,
//           when you enter all parameter and click OK, then it will encrypt
//           the PIN block with the PIN pad device key in DUKPT.
//           the PIN block can be formated with PIN and account number that 
//           you entered.
void CKeyInjectModuleDlg::Decryption() 
{
	unsigned long   counter;
	unsigned char  stringKSN[10];
	int bSessionIDLen;
	CString        message, strASCII, strHEX, strSessionID, strTmp;
	CDES           lcDES;
	CDUKPT         lcDUKPT;
	AesCipher	   lcAES;
	unsigned char  k=1;
	
	INT32U i;
	
	strASCII = _T("");
	strHEX = _T("");
	strSessionID = _T("");
	message = _T("");
	
	
	{
		
		memcpy(stringKSN, m_nksn,10);
		//calculate the counter
		counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
		stringKSN[9] = stringKSN[8] = 0;
		stringKSN[7] &= 0xE0;
        memset(m_cryptoKey, 0, 16);
		
		//get the m_cryptoKey
		
	   lcDUKPT.IDT_LoadInitKey(m_des_index,         // indicate whether the key is single- or double-length
							   m_ninitial_key,      // init key in binary
							   stringKSN);		
	
		do
		{	       
		   lcDUKPT.IDT_EncryptPIN(m_des_index,
								  lcDUKPT.IDT_ChangeCounter(counter, k),
								  stringKSN,            // returns the 10-byte KSN
								  m_cryptoKey,
								  0); 
		   k++;
		}while(k <= lcDUKPT.IDT_GetNumOfOnes(counter));
		
		
		if(m_CardType == 0){
			message = "Card Type: ISO/ABA\r\n";
		}else if (m_CardType == 1){
			message = "Card Type: AAMVA\r\n";
		}else if (m_CardType == 2){
			message = "Card Type: CADL\r\n";
		}else if (m_CardType == 3){
			message = "Card Type: Others\r\n";
		}
		
	
		if (EncodingType < 0x80)
		{
			// TDES Decryption
			if (bDecryptMode == 1)
			{
				unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};


				if (bTrk1)
				{	
					lcDES.des_cbc_decryption(1, m_Track1Buffer, m_cryptoKey, init_vector, (INT16U)((DataLen) >> 3));
					
					// Display Decrypted Data
					for(i = 0; i < DataLen; i++)
					{
						strTmp.Format("%C", m_Track1Buffer[i]);
						strASCII += strTmp;
					}
				
					strASCII += "\r\n";
					// Display Decrypted Data
					for(i = 0; i < DataLen; i++)
					{
						strTmp.Format("%02X", m_Track1Buffer[i]);
						strHEX += strTmp;
					}
				}	
			}

			
			else
			{
				unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};				
				lcAES.setIV(init_vector);
				lcAES.makeRoundKey(m_cryptoKey, DEFAULT_KEY_LENGTH);				
				
				if (bTrk1)
				{	
					lcAES.decryptString(m_Track1Buffer, m_Track1Buffer, (INT32U)DataLen, CBC);
					
					// Display Decrypted Data
					for(i = 0; i < DataLen; i++)
					{
						strTmp.Format("%C", m_Track1Buffer[i]);
						strASCII += strTmp;
					}
				
					strASCII += "\r\n";
					// Display Decrypted Data
					for(i = 0; i < DataLen; i++)
					{
						strTmp.Format("%02X", m_Track1Buffer[i]);
						strHEX += strTmp;
					}
				}				
			}
			
			if (HIDMode != 1) // USB HID
			{				
				if ((HID_Data[8]) && (EncodingType==0))
				{				
					for (i=HID_Data[6]+HID_Data[7]+9; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+9; i++)
					{		
						strTmp.Format("%C",HID_Data[i]);
						strASCII+= strTmp;
					}
				}
			}					
			
			else	// USB KB
			{								
				if ((USBKB_Data[8]) && (EncodingType==0))
					strASCII += StrUSBKB.Mid(16+USBKB_Data[6]+USBKB_Data[7],USBKB_Data[8]);
				
				GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
				GetDlgItem(IDC_COMMAND)->SetFocus();				
			}
			
		
			if (bActivation) // Display Section ID
			{	
				strSessionID += _T("\r\nSection ID: ");
				

				if (HIDMode != 1) // USB HID
				{
					for(i = HID_Data[6]+HID_Data[7]+HID_Data[8]; i < HID_Data[6]+HID_Data[7]+HID_Data[8]+8; i++)
					{
						strTmp.Format("%02X ", m_Track1Buffer[i]);
						strSessionID += strTmp;
					}				
				}
				
				else	// USB KB			
				{
					for(i = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]; i < USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+8; i++)
					{
						strTmp.Format("%02X ", m_Track1Buffer[i]);
						strSessionID += strTmp;
					}
				}
			}

		}
		
	
		
		else // if (EncodingType >= 0x80)
		{
			// TDES Decryption
			if (bDecryptMode == 1)	
			{
				unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};
				bSessionIDLen = 8;	
				
				if (bTrk1)
				{	
					lcDES.des_cbc_decryption(1, m_Track1Buffer, m_cryptoKey, init_vector, (INT16U)((DataLen1) >> 3));
					
					// Display Decrypted Data
					for(i = 0; i < DataLen1; i++)
					{
						strTmp.Format("%C", m_Track1Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i < DataLen1; i++)
					{
						strTmp.Format("%02X", m_Track1Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk2)
				{	
					lcDES.des_cbc_decryption(1, m_Track2Buffer, m_cryptoKey, init_vector, (INT16U)((DataLen2) >> 3));
					
					// Display Decrypted Data
					for(i = 0; i < DataLen2; i++)
					{
						strTmp.Format("%C", m_Track2Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i < DataLen2; i++)
					{
						strTmp.Format("%02X", m_Track2Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk3)
				{	
					lcDES.des_cbc_decryption(1, m_Track3Buffer, m_cryptoKey, init_vector, (INT16U)((DataLen3) >> 3));
					
					// Display Decrypted Data
					for(i = 0; i < DataLen3; i++)
					{
						strTmp.Format("%C", m_Track3Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i < DataLen3; i++)
					{
						strTmp.Format("%02X", m_Track3Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}	


				if (bActivation) // Display Section ID
				{	
					strSessionID = "\r\nSession ID: ";
					lcDES.des_cbc_decryption(1, m_SessionIDBuffer, m_cryptoKey, init_vector, (INT16U)((bSessionIDLen) >> 3));					
					
					// Display Decrypted Data
					for(i = 0; i < bSessionIDLen; i++)
					{
						strTmp.Format("%C", m_SessionIDBuffer[i]);
						strSessionID += strTmp;
					}
				}	
			}
					
				
				
			// AES Decryption
			else if (bDecryptMode == 2)					
			{
				unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};	
				lcAES.setIV(init_vector);
				lcAES.makeRoundKey(m_cryptoKey, DEFAULT_KEY_LENGTH);
				bSessionIDLen = 16;	
						
				if (bTrk1)
				{	
					lcAES.decryptString(m_Track1Buffer, m_Track1Buffer, (INT32U)DataLen1, CBC);
					
					// Display Decrypted Data
					for(i = 0; i < DataLen1; i++)
					{
						strTmp.Format("%C", m_Track1Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i < DataLen1; i++)
					{
						strTmp.Format("%02X", m_Track1Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk2)
				{	
					lcAES.decryptString(m_Track2Buffer, m_Track2Buffer, (INT32U)DataLen2, CBC);
					
					// Display Decrypted Data
					for(i = 0; i < DataLen2; i++)
					{
						strTmp.Format("%C", m_Track2Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i < DataLen2; i++)
					{
						strTmp.Format("%02X", m_Track2Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk3)
				{	
					lcAES.decryptString(m_Track3Buffer, m_Track3Buffer, (INT32U)DataLen3, CBC);
					
					// Display Decrypted Data
					for(i = 0; i < DataLen3; i++)
					{
						strTmp.Format("%C", m_Track3Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i < DataLen3; i++)
					{
						strTmp.Format("%02X", m_Track3Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}	


				if (bActivation) // Display Section ID
				{	
					strSessionID = "Session ID: ";
					lcAES.decryptString(m_SessionIDBuffer, m_SessionIDBuffer, (INT32U)bSessionIDLen, CBC);
					
					// Display Decrypted Data
					for(i = 0; i < bSessionIDLen; i++)
					{
						strTmp.Format("%C", m_SessionIDBuffer[i]);
						strSessionID += strTmp;
					}
				}
			}
		

			if (HIDMode == 1) // USB KB
			{
				GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
				GetDlgItem(IDC_COMMAND)->SetFocus();
			}				
		
		}
		
		strTmp.Format("Key Value: %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X", \
			m_cryptoKey[0],m_cryptoKey[1],m_cryptoKey[2], m_cryptoKey[3],m_cryptoKey[4],\
			m_cryptoKey[5], m_cryptoKey[6], m_cryptoKey[7],m_cryptoKey[8],m_cryptoKey[9],\
			m_cryptoKey[0x0a], m_cryptoKey[0x0b],m_cryptoKey[0x0c], \
			m_cryptoKey[0x0d], m_cryptoKey[0x0e], m_cryptoKey[0x0f]);
		
		message += strTmp;
		
		strTmp.Format("\r\nKSN: %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X", \
			glm_nksn[0],glm_nksn[1],glm_nksn[2], glm_nksn[3],glm_nksn[4],\
			glm_nksn[5], glm_nksn[6], glm_nksn[7],glm_nksn[8],glm_nksn[9]);
		
		message += strTmp;

		// Display Section ID
		if (bActivation)
			message += strSessionID;

		 
		message += "\r\n\r\nDecrypted Data:\r\n" + strASCII + "\r\n\r\n" + strHEX;
        ((CStatic *)GetDlgItem(IDC_RESP)) -> SetWindowText(message);
		
	}
}

void CKeyInjectModuleDlg::Received_HID_Data() 
{
	bUpdateDisplay = true;
}


void CKeyInjectModuleDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent==2)
	{
		CString strt;
		GetDlgItem(IDC_EDIT1)->GetWindowText(strt);
	    strt.Format("%d",(atoi(strt)-1));	
		GetDlgItem(IDC_EDIT1)->SetWindowText(strt);	
		if(strt=="0")
		{
			KillTimer(2);
			GetDlgItem(IDC_RESP)->SetWindowText("Finish" + strtt +"Sec: Time out !");
			GetDlgItem(IDC_EDIT1)->SetWindowText("60");
		}
		CString sa;
		GetDlgItem(IDC_COMMAND)->GetWindowText(sa);	
		if(sa!=cmd)
		{
				KillTimer(2);
				GetDlgItem(IDC_EDIT1)->SetWindowText("60");	
		}
	}
	if(bUpdateDisplay)
	{
		bUpdateDisplay = false;
	//	GetDlgItem(IDC_COMMAND)->GetWindowText(cmd);
		OnDecrypt();
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CKeyInjectModuleDlg::OnWSET2ErrornotificationAlt() 
{
	INTERFACE_TYPE emMyItfType; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName,StrResponse,StrTmp;
	int		m_ulDevIndex = 0;
	BYTE BufferTmp[500];
	ULONG	BufferLength = 500;
	int i, j;
	
	emMyItfType2 = ITF_TYPE_USB_HID;
	
	CMSRItfUSBHID	MSR(emMyItfType2);
	
	for (i=0; i<500; i++)
		BufferTmp[i] = 0;
	
	
	BYTE datapool[7];
	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x19;
	datapool[3] = 0x01;
	datapool[4] = 0x3d;
	datapool[5] = 0x03;
	datapool[6] = 0x77;
	int outLength = 7;
	
	for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
	{
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)			
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{
					Sleep(50); // make sure the device is not busy.
					MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
				}
			}
		}
	}
	
	if(m_ulDevIndex >= 10){
		emMyItfType2 = ITF_TYPE_USB_HID_KB;
		
		CMSRItfUSBHID	MSR(emMyItfType2);
		for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{
						Sleep(50); // make sure the device is not busy.
						MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
					}
				}
			}
		}		
	}
	if ( BufferTmp[0] == 6)
		MessageBox("W S/E, all T2 and Error Notification Alt command was sent successfully!","Status",MB_OK);				
	else
		MessageBox("Fail to send W S/E, all T2 and Error Notification Alt!",_T("Error"),MB_OK);				
	
	for (i=BufferLength; i>0; i--)
		if (BufferTmp[i] != 0)
			break;
		
		if (( BufferTmp[0] == 6) || ( BufferTmp[0] == 21))
			for (j=0; j<i+1; j++)
			{
				StrTmp.Format("%02X ",BufferTmp[j]);
				StrResponse += StrTmp;
			}
			
			//Show command text
			StrResponse = "CMD: 02 53 19 01 3D 03 77\r\nOUT: " + StrResponse;						
			GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
			
			MSR.CloseMSRDevice();		
}


/**************************************************/
/* Methods of Dialog
/**************************************************/


/**************************************************/
/* Events of Dialog
/**************************************************/
void CKeyInjectModuleDlg::OnInject() 
{
	if (IsOpen==1)
	{
		MessageBox("Please connect the USB cable and restart this demo without choosing Bluetooth Mode!");
	}
	else if(IsOpen==0)
	{
		UpdateData(TRUE);
		
		m_isFrist = TRUE;
		m_iInjectCount = 1;
		
		
		int iKeyPartVal = atoi(m_NoOfKeyPart);
		int iNumDevices = atoi(m_strNumDevices);
		
		m_NoOfDevices = iNumDevices;
		
		CString strMode = m_Encrypt;
		
		if((iNumDevices<1) || (iNumDevices>489335))
		{
			AfxMessageBox ("Number of Devices should be in Range: 1 - 489,335");
		}
		else
		{
			GetDlgItem(IDC_INPUT_KEY)->EnableWindow(FALSE);
			GetDlgItem(IDC_INJECT)->EnableWindow(FALSE);
			GetDlgItem(IDC_METHOD)->ShowWindow(FALSE);
			GetDlgItem(IDC_METHOD_LBL)->ShowWindow(FALSE);
			GetDlgItem(IDC_ENCPT)->ShowWindow(FALSE);
			GetDlgItem(IDC_ENCPT_LBL)->ShowWindow(FALSE);
			GetDlgItem(IDC_KEYPART)->ShowWindow(FALSE);
			GetDlgItem(IDC_NO_OF_KEY_PARTS)->ShowWindow(FALSE);
			GetDlgItem(IDC_NUM_DEVICES_LBL)->ShowWindow(FALSE);
			GetDlgItem(IDC_NUM_DEVICES)->ShowWindow(FALSE);
			GetDlgItem(IDC_ALGORITHM)->ShowWindow(FALSE);
			GetDlgItem(IDC_ABOUTKEY)->ShowWindow(FALSE);
			
			
//			GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(TRUE);
			GetDlgItem(IDC_KSN_GROUP)->ShowWindow(TRUE);
			
			GetDlgItem(IDC_IIN_LBL)->EnableWindow(TRUE);
			GetDlgItem(IDC_IIN_LBL)->ShowWindow(TRUE);
			GetDlgItem(IDC_IIN)->EnableWindow(TRUE);
			GetDlgItem(IDC_IIN)->SetWindowText(StrIDTECH_IIN);
			GetDlgItem(IDC_IIN)->ShowWindow(TRUE);
			
			GetDlgItem(IDC_DID_LBL)->EnableWindow(TRUE);
			GetDlgItem(IDC_DID_LBL)->ShowWindow(TRUE);
			
			
			CFile fDeviceID;
			CFileException ex;
			TCHAR *DID_Data;
			
			// Read Device ID from file
			if(fDeviceID.Open(".\\DID.txt", CFile::modeRead, &ex))		
			{
				int len = fDeviceID.GetLength();
				DID_Data = new TCHAR[len + 1];
				DID_Data[len] = '\0';
				fDeviceID.Read(DID_Data, len);
				CString szBuff(DID_Data);
				
				StrDID = szBuff;	
				fDeviceID.Close();
			}
			
			else
				StrDID = _T("000000");
			
			
			
			GetDlgItem(IDC_DID)->SetWindowText(StrDID);
			GetDlgItem(IDC_DID)->EnableWindow(TRUE);
			GetDlgItem(IDC_DID)->ShowWindow(TRUE);
			
			GetDlgItem(IDC_CID_LBL)->EnableWindow(TRUE);			
			GetDlgItem(IDC_CID_LBL)->ShowWindow(TRUE);			
			GetDlgItem(IDC_CID)->EnableWindow(TRUE);
			GetDlgItem(IDC_CID)->SetWindowText(_T("01"));
			GetDlgItem(IDC_CID)->ShowWindow(TRUE);
			
			
			char	dateStr[9];
			BYTE	Month, Year;
			CString StrGID;
			
			_strdate( dateStr);
			Month = asctodec(dateStr[0],dateStr[1]);
			Year = asctodec(dateStr[6],dateStr[7]) - 9;
			
			StrGID.Format("%01X%01X",Year,Month);			
			GetDlgItem(IDC_GID)->SetWindowText(StrGID);
			GetDlgItem(IDC_GID)->EnableWindow(TRUE);
			GetDlgItem(IDC_GID)->ShowWindow(TRUE);
			GetDlgItem(IDC_GID_LBL)->EnableWindow(TRUE);
			GetDlgItem(IDC_GID_LBL)->ShowWindow(TRUE);
			
			GetDlgItem(IDC_ENTER_KEY)->ShowWindow(TRUE);			
		}
	}
}

void CKeyInjectModuleDlg::OnCancel() 
{
	free(m_pMasterKey);
	free(m_pMasterKcv);
	free(m_pKsn);
	free(m_pKsnKcv);
	free(m_pBdk);
	free(m_pBdkKcv);
	
	CDialog::OnCancel();
}

void CKeyInjectModuleDlg::OnEnterKey() 
{
	CString CStrTemp_IIN,CStrTemp_CID,CStrTemp_GID;
	
	GetDlgItem(IDC_IIN)->GetWindowText(CStrTemp_IIN);
	GetDlgItem(IDC_CID)->GetWindowText(CStrTemp_CID);
	GetDlgItem(IDC_GID)->GetWindowText(CStrTemp_GID);
	GetDlgItem(IDC_DID)->GetWindowText(StrDID);
	
	
	StrKSN = CStrTemp_IIN + CStrTemp_CID + CStrTemp_GID + StrDID;
//	StrKSN = "FFFF9876543210E0";
	CallInjector (ET_TDES_DUKPT,atoi(m_NoOfKeyPart));
}

void CKeyInjectModuleDlg::OnInjectKey() 
{
	
 	BOOL bExitMethod=FALSE;
	
	int nResponse;
	int len =0;
	int iKEY_TYPE;
	int iKEY_TYPE_KSN;
	int iInjectLen=0;
	
	bool bRtrn=false;
	bool bKsnInject = true;
	
	CString strParity;
	
	byte* bInjectData = NULL;
	byte* pBKEY = (byte*)malloc(sizeof(byte) * 16);
	byte* pBKCV_Key = (byte*)malloc(sizeof(byte) * 3);
	byte* pBKSN = (byte*)malloc(sizeof(byte) * 10);
	byte* pBKCV_Ksn = (byte*) malloc(sizeof(byte)* 3);
	byte* pIK = (byte*) malloc(sizeof(byte)* 16);
	byte* pKCV_IK = (byte*) malloc(sizeof(byte)* 3);
	
	
	nResponse = 0;
	
	if((m_iCurrentOperation == ET_DES_MS) || (m_iCurrentOperation == ET_TDES_MS))
	{
		
		if(m_iCurrentOperation == ET_DES_MS)
		{
			
			memcpy(pBKEY,m_pMasterKey,8);
			iKEY_TYPE = KT_DES_MS;
			iInjectLen = 8;
			
		}
		else
		{
			memcpy(pBKEY,m_pMasterKey,16);
			iKEY_TYPE = KT_TDES_MS;
			iInjectLen = 16;
		}
		
		memcpy(pBKCV_Key,m_pMasterKcv,3);
		
	}
	else if(m_iCurrentOperation == ET_DES_DUKPT)
	{			
		if(m_iInjectCount == 1)
		{
			GetInitialKSN(m_pKsn);
		}
		else
		{
			GetNextKSN(m_pKsn);	
		}
		
		memcpy(pBKSN,m_pKsn,10);
		GetKeyCkeckValue(m_pKsn,pBKCV_Ksn,8,ET_DES_MS);
		
		GetIK(m_pKsn,m_pBdk,pIK,ET_DES_DUKPT);
		memcpy(pBKEY,pIK,8);
		
		GetKeyCkeckValue(pIK,pKCV_IK,16,ET_DES_MS);
		memcpy(pBKCV_Key,pKCV_IK,3);
		
		iInjectLen = 8;
		iKEY_TYPE = KT_DES_DUKPT_IK;
		iKEY_TYPE_KSN  = KT_DES_DUKPT_KSN;
		
	}
	else if(m_iCurrentOperation == ET_TDES_DUKPT) 
	{
		
		if(m_iInjectCount == 1)			
			GetInitialKSN(m_pKsn);
		
		else			
			GetNextKSN(m_pKsn);	
		
		byte ppp[16];
		memcpy(pBKSN,m_pKsn,10);
		GetKeyCkeckValue(m_pKsn,pBKCV_Ksn,8,ET_DES_MS);
		
		GetIK(m_pKsn,m_pBdk,pIK,ET_TDES_DUKPT);
		memcpy(pBKEY,pIK,16);
		
		memcpy(ppp,pIK,16);
		GetKeyCkeckValue(pIK,pKCV_IK,16,ET_TDES_DUKPT);
		memcpy(pBKCV_Key,pKCV_IK,3);
		
		iInjectLen = 16;
		iKEY_TYPE = KT_TDES_DUKPT_IK;
		iKEY_TYPE_KSN  = KT_TDES_DUKPT_KSN;
		
		
	}
	
	if(nResponse != 1)
	{
		{
			//Key Loading Mode
			int ipINT =0;
			bRtrn = SendToDevice(SYMBOL,0,false,NULL,NULL,&ipINT);
			if(!bRtrn)
			{
				MessageBox("Fail to enter Key Loading Mode","Status",MB_OK);
				bExitMethod=TRUE;
				
			}
			
			
			if(!bExitMethod)
			{
				{
					if( (m_iCurrentOperation == ET_DES_DUKPT) || ( m_iCurrentOperation == ET_TDES_DUKPT)  )
					{
						// load KSN						
						int iInjectLenKsn = 8;
						bRtrn = SendToDevice(SYMBOL,iKEY_TYPE_KSN,true,pBKSN,pBKCV_Ksn,&iInjectLenKsn);
						
						if(!bRtrn)
						{
							MessageBox("Fail to load KSN","Status",MB_OK);
							bKsnInject = false;
							
						}
						if(bKsnInject)
						{
							//load Key
							bRtrn = SendToDevice(SYMBOL,iKEY_TYPE,true,pBKEY,pBKCV_Key,&iInjectLen);
							if(!bRtrn)
							{
								MessageBox("Fail to load Key! Key Injection Failed!","Status",MB_OK);
								
							}
							else
							{
								if( (m_iCurrentOperation != ET_DES_DUKPT) ||  (m_iCurrentOperation != ET_TDES_DUKPT)  )
								{
									
									MessageBox("Key Injection Success!","Status",MB_OK);
									
									BYTE DID_Buffer[6];
									long unsigned int lDeviceID = 0;
									
									// Get Current DeviceID
									for (int i=0; i<3; i++)
									{
										DID_Buffer[i] = asctohex(StrDID.GetAt(2*i),StrDID.GetAt(2*i+1));
										lDeviceID = lDeviceID*256 + DID_Buffer[i];
									}
									
									// Update the new Device and write it to the file
									lDeviceID+=0x20;		
									
									if (lDeviceID > 0xFFFFFF)
										MessageBox("Device ID has exceeds its limit!");
									
									StrDID.Format("%06X",lDeviceID);
									
									CFile fDeviceID;
									CFileException ex;
									
									fDeviceID.Remove(".\\DID.txt");
									
									if(fDeviceID.Open(".\\DID.txt", CFile::modeWrite|CFile::modeCreate, &ex))		
										fDeviceID.Write(StrDID, 6);
									
									fDeviceID.Close();
									
									
								}
							}
							bKsnInject = true;
						}
						
					}
					
					if((m_iCurrentOperation == ET_DES_MS) || (m_iCurrentOperation == ET_TDES_MS) )
					{
						//MS  Key Injection  
						bRtrn = SendToDevice(SYMBOL,iKEY_TYPE,true,pBKEY,pBKCV_Key,&iInjectLen);
						
						if(!bRtrn)
							MessageBox("Key Injection Failed","Status",MB_OK);															
						
						else
						{
							if( (m_iCurrentOperation != ET_DES_DUKPT) ||  (m_iCurrentOperation != ET_TDES_DUKPT)  )
								MessageBox("Key Injection Success!","Status",MB_OK);
						}
						
					}
					
				}
			}		
			
		}
	}
	
	free(pBKEY);
	free(pBKCV_Key);
	free(pBKSN);
	free(pIK);
	free(pKCV_IK);
	free(pBKCV_Ksn);
	
	if((m_iInjectCount == m_NoOfDevices) && (nResponse != 1))
	{
		if( m_NoOfDevices !=1)	
		{
			AfxMessageBox("Reached The Final Key Serial Number");		
			
		}
		
		InitDlg();
		GetDlgItem(IDC_INPUT_KEY)->ShowWindow(TRUE);
		
		
	}
	if(nResponse != 1) 
		++m_iInjectCount ;
	
	if (m_NoOfDevices == 1)
	{
		GetDlgItem(IDC_INPUT_KEY)->ShowWindow(TRUE);
		GetDlgItem(IDC_ALGORITHM)->ShowWindow(TRUE);
		
		GetDlgItem(IDC_ENTER_KEY)->ShowWindow(FALSE);
		GetDlgItem(IDC_KSN_GROUP)->ShowWindow(FALSE);
		GetDlgItem(IDC_IIN_LBL)->ShowWindow(FALSE);
		GetDlgItem(IDC_IIN)->ShowWindow(FALSE);
		GetDlgItem(IDC_DID_LBL)->ShowWindow(FALSE);
		GetDlgItem(IDC_DID)->ShowWindow(FALSE);
		GetDlgItem(IDC_CID_LBL)->ShowWindow(FALSE);			
		GetDlgItem(IDC_CID)->ShowWindow(FALSE);
		GetDlgItem(IDC_GID_LBL)->ShowWindow(FALSE);
		GetDlgItem(IDC_GID)->ShowWindow(FALSE);
	}

	GetDlgItem(IDC_EXIT)->ShowWindow(TRUE);
	GetDlgItem(IDC_INPUT_KEY)->EnableWindow(TRUE);
}

void CKeyInjectModuleDlg::OnCancelDebit() 
{
	m_isFrist = TRUE;
	
	SetDlgItemText(IDC_NO_OF_KEY_PARTS,"2");
//	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_INJECT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_INPUT_KEY)->ShowWindow(TRUE);
	SetDlgItemText(IDC_ENCPT,"TDES");
	SetDlgItemText(IDC_METHOD,"Master/Session");			
	
//	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_ABOUTKEY)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_NO_OF_KEY_PARTS)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_KEYPART)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_OK)->EnableWindow(TRUE);
	
	GetDlgItem(IDC_ENCPT)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_ENCPT_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_METHOD)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_METHOD_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_CANCEL)->ShowWindow(FALSE);
	GetDlgItem(IDC_EXIT)->ShowWindow(TRUE);
	
	GetDlgItem(IDC_CANCEL_DEBIT)->ShowWindow(FALSE);
	
	GetDlgItem(IDC_NUM_DEVICES)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_NUM_DEVICES_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
	GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
	
	GetDlgItem(IDC_KSN_GROUP)->ShowWindow(FALSE);
	GetDlgItem(IDC_IIN_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_IIN)->ShowWindow(FALSE);
	GetDlgItem(IDC_DID_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_DID)->ShowWindow(FALSE);
	GetDlgItem(IDC_CID_LBL)->ShowWindow(FALSE);			
	GetDlgItem(IDC_CID)->ShowWindow(FALSE);
	GetDlgItem(IDC_GID_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_GID)->ShowWindow(FALSE);
	
	GetDlgItem(IDC_ALGORITHM)->ShowWindow(TRUE);
}

void CKeyInjectModuleDlg::OnInputKey() 
{
	CString strKey;
	CString strKeyConfirm;
	CString strTemp;
	CString strCheckVal;
	m_KetRtrvr.m_sCaption = "INPUT BDK";
	m_KetRtrvr.m_strLabel = "BDK";
	m_KetRtrvr.m_cPasswordChar = 0;
	m_KetRtrvr.m_strCaption = "";
	
	int iEncpt=0;
	int i=0;
	int iRspnsCheckVal =0;
	int iReturnStatus=0;
	
	BOOL bCancel = FALSE;
	BOOL bExitMethod = FALSE;
	
	byte* pInitialKey = NULL;
	pInitialKey =(byte*)malloc(sizeof(byte) * 16);
	
	for(int j=0;j<1;j++)
	{
		iReturnStatus = Getkey(32,pInitialKey);
		if( (iReturnStatus == 2) || (iReturnStatus == 1) )
		{
			--j;
			continue;
		}
		else if(iReturnStatus == 3)
		{
			bExitMethod = TRUE;
			break;
		}
	}
	
	for (i=0; i<16; i++)
		m_nderivation_key[i] = pInitialKey[i];
	
	bIK = true;
	
	free(pInitialKey);

	GetDlgItem(IDC_COMMAND)->SetFocus();
}

void CKeyInjectModuleDlg::OnSend() 
{
	int nSize,i;
	BOOL bRet=TRUE;
	BYTE CmdBuf[1000], CmdBuf2[1003], LRC = 0;
	CString		StrResponse, StrTmp;
	unsigned long RespLen = 3;
	//Open bluetooth ??
	if (IsOpen==1)
	{
		//get command text
		GetDlgItem(IDC_COMMAND)->GetWindowText(StrCommand);
		
		StrCommand.Remove(_T(' ')); //remove space
		StrCommand.Remove(_T('\t')); //remove tab
		
		
		if(StrCommand.IsEmpty())  // Check if the command string is empty
		{
			MessageBox(_T("Please Input the Command String!"), _T("Error"), MB_OK);
			return;
		}
		
		nSize = StrCommand.GetLength();
		
		// Convert the command to hex format
		bRet = MakeCommand(StrCommand, CmdBuf, &nSize);
		
		if(bRet == FALSE)
		{
			MessageBox(_T("The command text is too long or invalid!"), _T("Error"), MB_OK);
			return;
		}
		
		CmdBuf2[0] = 2;
		
		for(i=0; i<nSize; i++)
			CmdBuf2[i+1] = CmdBuf[i];
		
		CmdBuf2[i+1] = 3;
		
		for(i=0; i<nSize+2; i++)
			LRC ^= CmdBuf2[i];
		
		CmdBuf2[i] = LRC;
		
		
		nSize = i+1;		
		
		SendBluetoothCommand(CmdBuf2, nSize);
	//	SendCommandRequest(CmdBuf2, nSize);
	}//KB  ,HID,,,
	else
	{
		INTERFACE_TYPE emMyItfType; 
		ULONG emMyItfType1; 
		INTERFACE_TYPE emMyItfType2;
		CString strDevName;
		int		m_ulDevIndex = 0;
		emMyItfType1 = '1';
		emMyItfType2 = ITF_TYPE_USB_HID;
		CMSRItfUSBHID	MSR(emMyItfType2);
		for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)			
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{
						Sleep(50); // make sure the device is not busy.
						
						//get command text
						GetDlgItem(IDC_COMMAND)->GetWindowText(StrCommand);
						
						StrCommand.Remove(_T(' ')); //remove space
						StrCommand.Remove(_T('\t')); //remove tab
						
						
						if(StrCommand.IsEmpty())  // Check if the command string is empty
						{
							MessageBox(_T("Please Input the Command String!"), _T("Error"), MB_OK);
							goto EXIT;
						}
						
						nSize = StrCommand.GetLength();
						
						// Convert the command to hex formart
						bRet = MakeCommand(StrCommand, CmdBuf, &nSize);
						
						if(bRet == FALSE)
						{
							MessageBox(_T("The command text is too long or invalid!"), _T("Error"), MB_OK);
							goto EXIT;
						}
						
						
						CmdBuf2[0] = 2;
						
						for(i=0; i<nSize; i++)
							CmdBuf2[i+1] = CmdBuf[i];
						
						CmdBuf2[i+1] = 3;
						
						for(i=0; i<nSize+2; i++)
							LRC ^= CmdBuf2[i];
						
						CmdBuf2[i] = LRC;
						
						
						nSize = i+1;
						
						MSR.SendCommand2(CmdBuf2, nSize, StrResponse);
					}
					
					else
					{
						printf("Fail to open device! \n");
						MSR.CloseMSRDevice();
					}
				}
			}
		}
		
		if(m_ulDevIndex >= 10)
		{
			emMyItfType2 = ITF_TYPE_USB_HID_KB;
			
			CMSRItfUSBHID	MSR(emMyItfType2);
			for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
			{
				if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
				{
					if(emMyItfType != emMyItfType2)
						continue;
					else
					{
						if(MSR.OpenMSRDevice(m_ulDevIndex))
						{
							Sleep(50); // make sure the device is not busy.
							
							//get command text
							GetDlgItem(IDC_COMMAND)->GetWindowText(StrCommand);
							
							StrCommand.Remove(_T(' ')); //remove space
							StrCommand.Remove(_T('\t')); //remove tab
							
							
							if(StrCommand.IsEmpty())  // Check if the command string is empty
							{
								MessageBox(_T("Please Input the Command String!"), _T("Error"), MB_OK);
								goto EXIT;
							}
							
							nSize = StrCommand.GetLength();
							
							// Convert the command to hex formart
							bRet = MakeCommand(StrCommand, CmdBuf, &nSize);
							
							if(bRet == FALSE)
							{
								MessageBox(_T("The command text is too long or invalid!"), _T("Error"), MB_OK);
								goto EXIT;
							}
							
							CmdBuf2[0] = 2;
							
							for(i=0; i<nSize; i++)
								CmdBuf2[i+1] = CmdBuf[i];
							
							CmdBuf2[i+1] = 3;
							
							for(i=0; i<nSize+2; i++)
								LRC ^= CmdBuf2[i];
							
							CmdBuf2[i] = LRC;
							
							
							nSize = i+1;
							
							MSR.SendCommand2(CmdBuf2, nSize, StrResponse);
						}
						
						else
						{
							printf("Fail to open device! \n");
							MSR.CloseMSRDevice();
						}
					}
				}
			}		
		}
EXIT:
		MSR.CloseMSRDevice();

		//Send command to Change TDES or AES
		if( CmdBuf2[2]==0x4c&&CmdBuf2[4]==0x31&&strcmp(StrResponse.GetBuffer(StrResponse.GetLength()),"06 ")==0)
		{	
			
			
			bDecryptMode = 1;
		}
		else if(CmdBuf2[2]==0x4c&&CmdBuf2[4]==0x32&&strcmp(StrResponse.GetBuffer(StrResponse.GetLength()),"06 ")==0) 
		{
		
			bDecryptMode = 2;
		}
		StrCommand = "";
		for (i=0; i<nSize; i++)
		{
			StrTmp.Format("%02X ", CmdBuf2[i]);
			StrCommand += StrTmp;
		}
		StrResponse = "CMD: " + StrCommand + "\r\nOUT: " + StrResponse;
		
		GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
		
		StrCommand = "";
		GetDlgItem(IDC_COMMAND)->SetWindowText(StrCommand);
	
	}	
}

void CKeyInjectModuleDlg::OnDecrypt() 
{
	const TCHAR CR[] = {13, 0};
	BOOL bDecryption = false;
	unsigned char len = 0;
	unsigned char berror = 0;
	unsigned long counter;
	CString StringTmp, StrTmp;
	bTrk1 = bTrk2 = bTrk3 = false;
	unsigned int i;
	int EncryptedTrackLength = 0;
	int EncryptedTrack1Length = 0;
	int EncryptedTrack2Length = 0;
	int EncryptedTrack3Length = 0;
	int UnencryptedLength = 0;	
	int shiftSize = 0;
	//DES type
	m_des_index = 1;

	GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));

	//жbDecryptMode
	const int outLengt = 5;
	BYTE da[outLengt];
	da[0] = 0x02;
	da[1] = 0x52;
	da[2] = 0x4C;
	da[3] = 0x03;
	da[4] = 0x1f;
	//Open blue tooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(da, outLengt);
	}
	else
	{
		SendCommandRequest(da, outLengt);
	}
	//SendCommandRequest(da, outLengt);
	CString SResponse,STmp;
	// Get command request and response string
	GetDlgItemText(IDC_RESP,SResponse);
	STmp=SResponse;
	STmp.Remove(_T(' ')); //remove space
	STmp.Remove(_T('\t')); //remove tab
	STmp.Remove(_T('\r')); //remove CR
	STmp.Remove(_T('\n')); //remove new line
	int DataPo = STmp.Find("0602");
	if (STmp.Mid(DataPo+4, 6)=="4C0131")
	{
		bDecryptMode=1;
	}
	else if (STmp.Mid(DataPo+4, 6)=="4C0132")
	{
		bDecryptMode=2;
	}
	else if (STmp.Mid(DataPo+4, 6)=="4C0130")
	{
		bDecryptMode=0;
	}

	//жHIDMode
	const int outLeng = 5;
	BYTE datap[outLeng];
	datap[0] = 0x02;
	datap[1] = 0x52;
	datap[2] = 0x23;
	datap[3] = 0x03;
	datap[4] = 0x70;
	//Open blue tooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datap, outLeng);
	}
	else
	{
		SendCommandRequest(datap, outLeng);
	}
//	SendCommandRequest(datap, outLeng);
	CString SRespons,STm;
	// Get command request and response string
	GetDlgItemText(IDC_RESP,SRespons);
	STm=SRespons;
	STm.Remove(_T(' ')); //remove space
	STm.Remove(_T('\t')); //remove tab
	STm.Remove(_T('\r')); //remove CR
	STm.Remove(_T('\n')); //remove new line
	int DataP = STm.Find("0602");
	if (STm.Mid(DataP+4, 6)=="230130")
	{
		HIDMode=0;
	}
	else if (STm.Mid(DataP+4, 6)=="230138")
	{
		HIDMode=1;
	}
	else if (STm.Mid(DataP+4, 6)=="23013 1")
	{
		HIDMode=2;
	}
	GetDlgItem(IDC_RESP)->SetWindowText(_T(""));
	//ʼ
	if (bDecryptMode)
	{
		if ((HIDMode != 1)||(IsOpen==1)) // USB HID//HIDMode != 1
		{
			int Length;		
			BYTE TempLRC=0;
			BYTE TempCheckSum=0;
			CString StrTemp;
			// Check Length
			Length = HID_Data[3]*256 + HID_Data[2];	
			StrTemp.Format("Length error!\r\nLength from Data: %04X\r\nCalculated Length: %04X",Length, HID_Data_Length-7);
		    if ( Length != HID_Data_Length-7)
				MessageBox(StrTemp);
			// LRC
			for (i=4; i<HID_Data_Length-3; i++)
				TempLRC ^= HID_Data[i];
			StrTemp.Format("LRC error!\r\nLRC from Data: %04X\r\nCalculated LRC: %04X",HID_Data[HID_Data_Length-3], TempLRC);			
			if (TempLRC != HID_Data[HID_Data_Length-3])
				MessageBox(StrTemp);
			// CheckSum
			for (i=4; i<HID_Data_Length-3; i++)
				TempCheckSum += HID_Data[i];			
			StrTemp.Format("CheckSum error!\r\nCheckSum from Data: %04X\r\nCalculated CheckSum: %04X",HID_Data[HID_Data_Length-2], TempCheckSum);
			if (TempCheckSum != HID_Data[HID_Data_Length-2])
				MessageBox(StrTemp);

			EncodingType = HID_Data[4];
			if (EncodingType < 0x80)
			{	
				// Non ISO/ABA Data Output Format
				if ((EncodingType == 1) || (EncodingType == 3))
				{
					StrTmp = "Reader Output: (Non ISO/ABA Data Output Format)\r\n";
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}							
					StrTmp += "\r\n\r\nCard Data:\r\n";
					if (HID_Data[6])
					{				
						for (i=0; i<HID_Data[6]; i++)
						{		
							StringTmp.Format("%C",HID_Data[i+9]);
							StrTmp += StringTmp;
						}
					}					
					if (HID_Data[7])
					{				
						for (i=HID_Data[6]+9; i<HID_Data[6]+HID_Data[7]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}					
					if (HID_Data[8])
					{				
						for (i=HID_Data[6]+HID_Data[7]+9; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}				
					GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);				
					StrTmp = "";        
					GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
				}

				// ISO/ABA Data Output Format
				else if (EncodingType == 0)				
				{
					StrTmp += "Reader Output: (ISO/ABA Data Output Format)";
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];					
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}										
					StrTmp += "\r\n\r\nMasked Data: ";
					if (HID_Data[6])
					{	
						StrTmp += "\r\nTrack 1: ";						
						for (i=0; i<HID_Data[6]; i++)
						{		
							StringTmp.Format("%C",HID_Data[i+9]);
							StrTmp += StringTmp;
						}
					}					
					if (HID_Data[7])
					{
						StrTmp += "\r\nTrack 2: ";						
						for (i=HID_Data[6]+9; i<HID_Data[6]+HID_Data[7]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}					
					if (HID_Data[8])
					{
						StrTmp += "\r\nTrack 3: ";						
						for (i=HID_Data[6]+HID_Data[7]+9; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}					
					UnencryptedLength = HID_Data[6]+HID_Data[7]+HID_Data[8];

					// Security Level=4
					if (bActivation)
						shiftSize = 8;
					else
						shiftSize = 0;
					
					if (bDecryptMode == 1) // TDES
					{
						if (((HID_Data[6] + HID_Data[7]+shiftSize) % 8) == 0)
							EncryptedTrackLength = HID_Data[6] + HID_Data[7]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6] + HID_Data[7]+shiftSize) / 8 + 1) * 8;
					}					
					else if (bDecryptMode == 2) // AES
					{
						if (((HID_Data[6] + HID_Data[7]+shiftSize) % 16) == 0)
							EncryptedTrackLength = HID_Data[6] + HID_Data[7]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6] + HID_Data[7]+shiftSize) / 16 + 1) * 16;
					}	
					
					DataLen = EncryptedTrackLength;					
					for (i = 0; i<EncryptedTrackLength; i++)
						m_Track1Buffer[i] = HID_Data[i+UnencryptedLength+9];					
					bTrk1 = true;
					bDecryption = true;						
					GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);										
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
					//Initial key
					if (!bIK)
					{
						m_str_initial_key = StrInitialKey;
						len = m_str_initial_key.GetLength();						
						for(i=0; i<len/2; i++)							
							m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
					}										
					counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
					if(!counter) 
					{
						berror = 1;
						MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
					}					
					GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);					
					Decryption();
				}

				// Raw Data Output Format
				else if (EncodingType == 4)				
				{
					StrTmp += "Reader Output: (Raw Data Output Format)";
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];					
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}									
					int UnencryptedLength = HID_Data[6]+HID_Data[7]+HID_Data[8];				
					// Security Level=4
					if (bActivation)
						shiftSize = 8;
					else
						shiftSize = 0;
		
					if (bDecryptMode == 1) // TDES
					{
						if (((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) % 8) == 0)
							EncryptedTrackLength = HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) / 8 + 1) * 8;
					}					
					else if (bDecryptMode == 2) // AES
					{
						if (((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) % 16) == 0)
							EncryptedTrackLength = HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) / 16 + 1) * 16;
					}
					
					DataLen = EncryptedTrackLength;					
					for (i = 0; i<EncryptedTrackLength; i++)
						m_Track1Buffer[i] = HID_Data[i+9];					
					bTrk1 = true;
					bDecryption = true;						
					GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);										
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
					//Initial key
					if (!bIK)
					{
						m_str_initial_key = StrInitialKey;
						len = m_str_initial_key.GetLength();						
						for(i=0; i<len/2; i++)							
							m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
					}										
					counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
					if(!counter) 
					{
						berror = 1;
						MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
					}					
					GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);										
					Decryption();
				}
			}

			else // if (EncodingType >= 0x80)
			{
				// Non ISO/ABA Data Output Format
				if ((EncodingType == 0x81) || (EncodingType == 0x83))
				{
					StrTmp = "Reader Output: (Non ISO/ABA New Data Output Format)\r\n";
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}										
					StrTmp += "\r\n\r\nCard Data:\r\n";
					if (HID_Data[6])
					{				
						for (i=0; i<HID_Data[6]; i++)
						{		
							StringTmp.Format("%C",HID_Data[i+11]);
							StrTmp += StringTmp;
						}
					}					
					if (HID_Data[7])
					{				
						for (i=HID_Data[6]+11; i<HID_Data[6]+HID_Data[7]+11; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}										
					if (HID_Data[8])
					{				
						for (i=HID_Data[6]+HID_Data[7]+11; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+11; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}					
					GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);					
					StrTmp = "";        
					GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
				}
				
				// ISO/ABA Data Output Format
				else if (EncodingType == 0x80)				
				{				
					StrTmp += "Reader Output: (ISO/ABA New Data Output Format)";
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];				
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}
					/*
						Clear/mask data sent status byte:
						bit 0: 1--- if TK1 clear/mask data present 
						bit 1: 1--- if TK2 clear/mask data present
						bit 2: 1--- if TK3 clear/mask data present
						Bit 3:0-0
						Bit 4:0-0
						Bit 5:0-0
					*/
					BYTE bClearMaskDataStatus = HID_Data[9];
					if (bClearMaskDataStatus)
						StrTmp += "\r\n\r\nMasked Data: ";		
					if (HID_Data[6])
					{
						bTrk1 = true;
						if (bClearMaskDataStatus & 1)
						{	
							StrTmp += "\r\nTrack 1: ";							
							for (i=0; i<HID_Data[6]; i++)
							{		
								StringTmp.Format("%C",HID_Data[i+11]);
								StrTmp += StringTmp;
							}
							UnencryptedLength += HID_Data[6];
						}
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[6] % 8) == 0)
								EncryptedTrack1Length = HID_Data[6];
							else
								EncryptedTrack1Length = (HID_Data[6] / 8 + 1) * 8;
						}					
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[6] % 16) == 0)
								EncryptedTrack1Length = HID_Data[6];
							else
								EncryptedTrack1Length = (HID_Data[6] / 16 + 1) * 16;
						}						
						DataLen1 = EncryptedTrack1Length;						
					}					
					if (HID_Data[7])
					{
						bTrk2 = true;
						if (bClearMaskDataStatus & 2)
						{
							StrTmp += "\r\nTrack 2: ";							
							for (i=UnencryptedLength+11; i<UnencryptedLength+HID_Data[7]+11; i++)
							{		
								StringTmp.Format("%C",HID_Data[i]);
								StrTmp += StringTmp;
							}
							UnencryptedLength += HID_Data[7];
						}		
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[7] % 8) == 0)
								EncryptedTrack2Length = HID_Data[7];
							else
								EncryptedTrack2Length = (HID_Data[7] / 8 + 1) * 8;
						}					
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[7] % 16) == 0)
								EncryptedTrack2Length = HID_Data[7];
							else
								EncryptedTrack2Length = (HID_Data[7] / 16 + 1) * 16;
						}
						DataLen2 = EncryptedTrack2Length;						
					}									
					if (HID_Data[8])
					{
						bTrk3 = true;
						if (bClearMaskDataStatus & 4)
						{
							StrTmp += "\r\nTrack 3: ";					
							for (i=UnencryptedLength+11; i<UnencryptedLength+HID_Data[8]+11; i++)
							{		
								StringTmp.Format("%C",HID_Data[i]);
								StrTmp += StringTmp;
							}
							UnencryptedLength += HID_Data[8];
						}
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[8] % 8) == 0)
								EncryptedTrack3Length = HID_Data[8];
							else
								EncryptedTrack3Length = (HID_Data[8] / 8 + 1) * 8;
						}						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[8] % 16) == 0)
								EncryptedTrack3Length = HID_Data[8];
							else
								EncryptedTrack3Length = (HID_Data[8] / 16 + 1) * 16;
						}		
						DataLen3 = EncryptedTrack3Length;
					}
					if (bTrk1)
						for (i = 0; i<EncryptedTrack1Length; i++)
							m_Track1Buffer[i] = HID_Data[i+UnencryptedLength+11];
					if (bTrk2)
						for (i = 0; i<EncryptedTrack2Length; i++)
							m_Track2Buffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+11];					
					if (bTrk3)
						for (i = 0; i<EncryptedTrack3Length; i++)
							m_Track3Buffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+11];	
					// Security Level=4
					if (bActivation)
					{	
						if (bDecryptMode == 1) // TDES
						{
							for (i = 0; i<8; i++)
								m_SessionIDBuffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
						}						
						else if (bDecryptMode == 2) // AES
						{
							for (i = 0; i<16; i++)
								m_SessionIDBuffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
						}
					}						
					/*
						Encrypted data sent status
						bit 0: if 1-tk1 encrypted data present 
						bit 1: if 1-tk2 encrypted data present
						bit 2: if 1-tk3 encrypted data present
						bit 3: if 1-tk1 hash data present
						bit 4: if 1-tk2 hash data present
						bit 5: if 1-tk3 hash data present
						Bit 6: if 1-session ID present 
						Bit 7: if 1-KSN present
					*/
					BYTE bEncryptedDataStatus = HID_Data[10];						
					bDecryption = true;						
					GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);					
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];								
					//Initial key
					if (!bIK)
					{
						m_str_initial_key = StrInitialKey;
						len = m_str_initial_key.GetLength();						
						for(i=0; i<len/2; i++)							
							m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
					}										
					counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
					if(!counter) 
					{
						berror = 1;
						MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
					}					
					GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);					
					Decryption();
				}

				// Raw Data Output Format
				else if (EncodingType == 0x84)				
				{
					StrTmp += "Reader Output: (Raw Data New Output Format)";											
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];					
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}									
					if (HID_Data[6])
					{
						bTrk1 = true;					
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[6] % 8) == 0)
								EncryptedTrack1Length = HID_Data[6];
							else
								EncryptedTrack1Length = (HID_Data[6]/ 8 + 1) * 8;
						}						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[6] % 16) == 0)
								EncryptedTrack1Length = HID_Data[6];
							else
								EncryptedTrack1Length = (HID_Data[6] / 16 + 1) * 16;
						}			
						DataLen1 = EncryptedTrack1Length;						
					}											
					if (HID_Data[7])
					{
						bTrk2 = true;					
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[7] % 8) == 0)
								EncryptedTrack2Length = HID_Data[7];
							else
								EncryptedTrack2Length = (HID_Data[7] / 8 + 1) * 8;
						}						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[7] % 16) == 0)
								EncryptedTrack2Length = HID_Data[7];
							else
								EncryptedTrack2Length = (HID_Data[7] / 16 + 1) * 16;
						}
						DataLen2 = EncryptedTrack2Length;						
					}						
					if (HID_Data[8])
					{
						bTrk3 = true;					
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[8] % 8) == 0)
								EncryptedTrack3Length = HID_Data[8];
							else
								EncryptedTrack3Length = (HID_Data[8] / 8 + 1) * 8;
						}						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[8] % 16) == 0)
								EncryptedTrack3Length = HID_Data[8];
							else
								EncryptedTrack3Length = (HID_Data[8] / 16 + 1) * 16;
						}					
						DataLen3 = EncryptedTrack3Length;
					}
					if (bTrk1)
						for (i = 0; i<EncryptedTrack1Length; i++)
							m_Track1Buffer[i] = HID_Data[i+11];
					if (bTrk2)
						for (i = 0; i<EncryptedTrack2Length; i++)
							m_Track2Buffer[i] = HID_Data[i+EncryptedTrack1Length+11];					
					if (bTrk3)
						for (i = 0; i<EncryptedTrack3Length; i++)
							m_Track3Buffer[i] = HID_Data[i+EncryptedTrack1Length+EncryptedTrack2Length+11];
					// Security Level=4
					if (bActivation)
					{	
						if (bDecryptMode == 1) // TDES
						{
							for (i = 0; i<8; i++)
								m_SessionIDBuffer[i] = HID_Data[i+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
						}					
						else if (bDecryptMode == 2) // AES
						{
							for (i = 0; i<16; i++)
								m_SessionIDBuffer[i] = HID_Data[i+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
						}
					}			
					/*
						Encrypted data sent status
						bit 0: if 1-tk1 encrypted data present 
						bit 1: if 1-tk2 encrypted data present
						bit 2: if 1-tk3 encrypted data present
						bit 3: if 1-tk1 hash data present
						bit 4: if 1-tk2 hash data present
						bit 5: if 1-tk3 hash data present
						Bit 6: if 1-session ID present 
						Bit 7: if 1-KSN present
					*/
					BYTE bEncryptedDataStatus = HID_Data[10];						
					bDecryption = true;						
					GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);					
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
					//Initial key
					if (!bIK)
					{
						m_str_initial_key = StrInitialKey;
						len = m_str_initial_key.GetLength();						
						for(i=0; i<len/2; i++)							
							m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
					}										
					counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
					if(!counter) 
					{
						berror = 1;
						MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
					}					
					GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);					
					Decryption();
				}
			}
		}
		
		else	// USB KB
		{			
			GetDlgItem(IDC_COMMAND)->GetWindowText(StrUSBKB);
			USBKB_Data_Length = StrUSBKB.GetLength();			
			if (USBKB_Data_Length > 0)
			{						
				int Length;
				BYTE TempData[1000];
				BYTE TempLRC=0;
				BYTE TempCheckSum=0;
				CString StrTemp;				
				for (i=0; i<10; i++)
					USBKB_Data[i+1] = asctohex(StrUSBKB.GetAt(2*i),StrUSBKB.GetAt(2*i+1));
				// Check Length
				Length = USBKB_Data[3]*256 + USBKB_Data[2];	
				StrTemp.Format("Length error!\r\nLength from Data: %04X\r\nCalculated Length: %04X",Length, USBKB_Data_Length-12);
				if ( Length != USBKB_Data_Length-12)
					MessageBox(StrTemp);
				for (i=0; i<USBKB_Data_Length; i++)
					TempData[i] = StrUSBKB.GetAt(i);
				// LRC
				for (i=6; i<USBKB_Data_Length-6; i++)
					TempLRC ^= TempData[i];
				StrTemp.Format("LRC error!\r\nLRC from Data: %04X\r\nCalculated LRC: %04X",asctohex(StrUSBKB.GetAt(USBKB_Data_Length-6),StrUSBKB.GetAt(USBKB_Data_Length-5)), TempLRC);				
				if (TempLRC != asctohex(StrUSBKB.GetAt(USBKB_Data_Length-6),StrUSBKB.GetAt(USBKB_Data_Length-5)))
					MessageBox(StrTemp);
				// CheckSum
				for (i=6; i<USBKB_Data_Length-6; i++)
					TempCheckSum += TempData[i];				
				StrTemp.Format("CheckSum error!\r\nCheckSum from Data: %04X\r\nCalculated CheckSum: %04X",asctohex(StrUSBKB.GetAt(USBKB_Data_Length-4),StrUSBKB.GetAt(USBKB_Data_Length-3)), TempCheckSum);
				if (TempCheckSum != asctohex(StrUSBKB.GetAt(USBKB_Data_Length-4),StrUSBKB.GetAt(USBKB_Data_Length-3)))
					MessageBox(StrTemp);
				EncodingType = USBKB_Data[4];
				if (EncodingType < 0x80)
				{
					// Non ISO/ABA Data Output Format
					if ((EncodingType == 1) || (EncodingType == 3))
					{
						StrTmp = "Reader Output: (Non ISO/ABA Data Output Format)\r\n";						
						if (USBKB_Data[6])										
							StrTmp += StrUSBKB.Mid(13,USBKB_Data[6]);											
						if (USBKB_Data[7])
							StrTmp += StrUSBKB.Mid(13+USBKB_Data[6],USBKB_Data[7]);												
						if (USBKB_Data[8])
							StrTmp += StrUSBKB.Mid(13+USBKB_Data[6]+USBKB_Data[7],USBKB_Data[8]);												
						GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
						StrTmp = "";        
						GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
					}
					// ISO/ABA Data Output Format
					else if (EncodingType == 0)				
					{			
						// Security Level=4
						if (bActivation)
							shiftSize = 8;
						else
							shiftSize = 0;
						if (bDecryptMode == 1) // TDES
						{
							if (((USBKB_Data[6]+USBKB_Data[7]+shiftSize)%8) == 0)
								EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+shiftSize)/8 + 1)*8; 
						}
						else if (bDecryptMode == 2) // AES
						{
							if (((USBKB_Data[6]+USBKB_Data[7]+shiftSize)%16) == 0)
								EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+shiftSize)/16 + 1)*16; 
							
						}
						DataLen = EncryptedTrackLength;
						UnencryptedLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8];
						for (i = 0; i<EncryptedTrackLength; i++)
							m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+16+2*i),StrUSBKB.GetAt(UnencryptedLength+17+2*i));						
						for (i=0; i<10; i++)			
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));							
						bTrk1 = true;
						bDecryption = true;	
						for(i=0; i<10; i++)	
							m_nksn[i] = glm_nksn[i];			
						
						//Initial key
						if (!bIK)
						{
							m_str_initial_key = StrInitialKey;
							len = m_str_initial_key.GetLength();
							for(i=0; i<len/2; i++)							
								m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
						}					
						counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
						if(!counter) 
						{
							berror = 1;
							MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
						}
						GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);
						Decryption();
					}

					// Raw Data Output Format
					else if (EncodingType == 4)				
					{			
						// Security Level=4
						if (bActivation)
							shiftSize = 8;
						else
							shiftSize = 0;
						if (bDecryptMode == 1) // TDES
						{
							if (((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)%8) == 0)
								EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)/8 + 1)*8; 
						}
						else if (bDecryptMode == 2) // AES
						{
							if (((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)%16) == 0)
								EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)/16 + 1)*16; 
						}
						DataLen = EncryptedTrackLength;
						for (i = 0; i<EncryptedTrackLength; i++)
							m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(16+2*i),StrUSBKB.GetAt(17+2*i));
						for (i=0; i<10; i++)			
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));
						bTrk1 = true;
						bDecryption = true;	
						for(i=0; i<10; i++)	
							m_nksn[i] = glm_nksn[i];			
						
						//Initial key
						if (!bIK)
						{
							m_str_initial_key = StrInitialKey;
							len = m_str_initial_key.GetLength();
							for(i=0; i<len/2; i++)							
								m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
						}					
						counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
						if(!counter) 
						{
							berror = 1;
							MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
						}
						GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);
						Decryption();
					}
				}

				else // if (EncodingType >= 0x80)
				{
					// Non ISO/ABA Data Output Format
					if ((EncodingType == 0x81) || (EncodingType == 0x83))
					{
						StrTmp = "Reader Output: (Non ISO/ABA Data Output Format)\r\n";	
						if (USBKB_Data[6])										
							StrTmp += StrUSBKB.Mid(17,USBKB_Data[6]);		
						if (USBKB_Data[7])
							StrTmp += StrUSBKB.Mid(17+USBKB_Data[6],USBKB_Data[7]);		
						if (USBKB_Data[8])
							StrTmp += StrUSBKB.Mid(17+USBKB_Data[6]+USBKB_Data[7],USBKB_Data[8]);	
						GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
						StrTmp = "";        
						GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
					}
					// ISO/ABA Data Output Format
					else if (EncodingType == 0x80)				
					{			/*
							Clear/mask data sent status byte:
							bit 0: 1--- if TK1 clear/mask data present 
							bit 1: 1--- if TK2 clear/mask data present
							bit 2: 1--- if TK3 clear/mask data present
							Bit 3:0-0
							Bit 4:0-0
							Bit 5:0-0
						*/
						BYTE bClearMaskDataStatus = USBKB_Data[9];
				//		UnencryptedLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8];	
						if (USBKB_Data[6])
						{
							bTrk1 = true;
							if (bClearMaskDataStatus & 1)							
								UnencryptedLength += USBKB_Data[6];
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[6] % 8) == 0)
									EncryptedTrack1Length = USBKB_Data[6];
								else
									EncryptedTrack1Length = (USBKB_Data[6] / 8 + 1) * 8;
							}
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[6] % 16) == 0)
									EncryptedTrack1Length = USBKB_Data[6];
								else
									EncryptedTrack1Length = (USBKB_Data[6] / 16 + 1) * 16;
							}		
							DataLen1 = EncryptedTrack1Length;
						}		
						if (USBKB_Data[7])
						{
							bTrk2 = true;
							if (bClearMaskDataStatus & 2)							
								UnencryptedLength += USBKB_Data[7];
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[7] % 8) == 0)
									EncryptedTrack2Length = USBKB_Data[7];
								else
									EncryptedTrack2Length = (USBKB_Data[7] / 8 + 1) * 8;
							}
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[7] % 16) == 0)
									EncryptedTrack2Length = USBKB_Data[7];
								else
									EncryptedTrack2Length = (USBKB_Data[7] / 16 + 1) * 16;
							}
							DataLen2 = EncryptedTrack2Length;
						}
						if (USBKB_Data[8])
						{
							bTrk3 = true;
							if (bClearMaskDataStatus & 4)							
								UnencryptedLength += USBKB_Data[8];
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[8] % 8) == 0)
									EncryptedTrack3Length = USBKB_Data[8];
								else
									EncryptedTrack3Length = (USBKB_Data[8] / 8 + 1) * 8;
							}
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[8] % 16) == 0)
									EncryptedTrack3Length = USBKB_Data[8];
								else
									EncryptedTrack3Length = (USBKB_Data[8] / 16 + 1) * 16;
							}
							DataLen3 = EncryptedTrack3Length;
						}
						if (bTrk1)
							for (i = 0; i<EncryptedTrack1Length; i++)
								m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+20+2*i),StrUSBKB.GetAt(UnencryptedLength+21+2*i));
						if (bTrk2)
							for (i = 0; i<EncryptedTrack2Length; i++)
								m_Track2Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+21+2*i));				
						if (bTrk3)
							for (i = 0; i<EncryptedTrack3Length; i++)
								m_Track3Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+21+2*i));		
						// Security Level=4
						if (bActivation)
						{	
							if (bDecryptMode == 1) // TDES
							{
								for (i = 0; i<8; i++)
									m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
							}
							else if (bDecryptMode == 2) // AES
							{
								for (i = 0; i<16; i++)
									m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
							}
						}
						for (i=0; i<10; i++)			
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));		
						bDecryption = true;	
						for(i=0; i<10; i++)	
							m_nksn[i] = glm_nksn[i];			
						
						//Initial key
						if (!bIK)
						{
							m_str_initial_key = StrInitialKey;
							len = m_str_initial_key.GetLength();
							for(i=0; i<len/2; i++)							
								m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
						}				
						counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
						if(!counter) 
						{
							berror = 1;
							MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
						}
						GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);
						Decryption();
					}

					// Raw Data Output Format
					else if (EncodingType == 0x84)				
					{	
						if (USBKB_Data[6])
						{
							bTrk1 = true;	
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[6] % 8) == 0)
									EncryptedTrack1Length = USBKB_Data[6];
								else
									EncryptedTrack1Length = (USBKB_Data[6] / 8 + 1) * 8;
							}
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[6] % 16) == 0)
									EncryptedTrack1Length = USBKB_Data[6];
								else
									EncryptedTrack1Length = (USBKB_Data[6] / 16 + 1) * 16;
							}
							for (i = 0; i<EncryptedTrack1Length; i++)
								m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(20+2*i),StrUSBKB.GetAt(21+2*i));
							DataLen1 = EncryptedTrack1Length;
						}
						if (USBKB_Data[7])
						{
							bTrk2 = true;
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[7] % 8) == 0)
									EncryptedTrack2Length = USBKB_Data[7];
								else
									EncryptedTrack2Length = (USBKB_Data[7] / 8 + 1) * 8;
							}
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[7] % 16) == 0)
									EncryptedTrack2Length = USBKB_Data[7];
								else
									EncryptedTrack2Length = (USBKB_Data[7] / 16 + 1) * 16;
							}
							for (i = 0; i<EncryptedTrack2Length; i++)
								m_Track2Buffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+21+2*i));
							DataLen2 = EncryptedTrack2Length;
						}
							
						if (USBKB_Data[8])
						{
							bTrk3 = true;
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[8] % 8) == 0)
									EncryptedTrack3Length = USBKB_Data[8];
								else
									EncryptedTrack3Length = (USBKB_Data[8] / 8 + 1) * 8;
							}
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[8] % 16) == 0)
									EncryptedTrack3Length = USBKB_Data[8];
								else
									EncryptedTrack3Length = (USBKB_Data[8] / 16 + 1) * 16;
							}
							for (i = 0; i<EncryptedTrack3Length; i++)
								m_Track3Buffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+21+2*i));
							DataLen3 = EncryptedTrack3Length;
						}
						// Security Level=4
						if (bActivation)
						{	
							if (bDecryptMode == 1) // TDES
							{
								for (i = 0; i<8; i++)
									m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
							}
							else if (bDecryptMode == 2) // AES
							{
								for (i = 0; i<16; i++)
									m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
							}
						}
						for (i=0; i<10; i++)			
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));	
						bDecryption = true;	
						for(i=0; i<10; i++)	
							m_nksn[i] = glm_nksn[i];			
						
						//Initial key
						if (!bIK)
						{
							m_str_initial_key = StrInitialKey;
							len = m_str_initial_key.GetLength();
							for(i=0; i<len/2; i++)							
								m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
						}						
						counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
						if(!counter) 
						{
							berror = 1;
							MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
						}
						GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);
						Decryption();
					}
				}	
			}
		}
	}
	else
	{
		if (!HIDMode)	// ID Tech USB HID Mode
		{
			if (HID_Data[1]==0)
			{
				for (i=10; i<HID_Data_Length; i++)
				{		
					if (HID_Data[i] == 13)
						StrTmp += "\r\n";		
					else
					{
						StringTmp.Format("%C",(BYTE)HID_Data[i]);
						StrTmp += StringTmp;		
					}
				}
				GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
			}
			else if (HID_Data[1]==2)	
			{
				for (i=9; i<HID_Data_Length-2; i++)
				{		
					if (HID_Data[i] == 13)
						StrTmp += "\r\n";		
					else
					{
						StringTmp.Format("%C",(BYTE)HID_Data[i]);
						StrTmp += StringTmp;		
					}
				}
				GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
			}
		}
		else if (HIDMode == 1)		// ID Tech USB HID KB Mode
		{
			for (i=0; i<HID_Data_Length; i++)
			{		
				if (HID_Data[i] == 13)
					StrTmp += "\r\n";		
				else
				{
					StringTmp.Format("%C",(BYTE)HID_Data[i]);
					StrTmp += StringTmp;		
				}
			}
			GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
		}	
	}
}

void CKeyInjectModuleDlg::OnExit() 
{
	OnCancel();
}


/**************************************************/
/* Methods of Main Menu
/**************************************************/
bool CKeyInjectModuleDlg::SendCommandRequest(byte* datapool, int outLength)
{	
	
	CString strDevName, StrResponse, StrTmp;
	int	m_ulDevIndex = 0;
	int i, j;
	bool isFound = false;
	bool cmdSucceed = false;

	INTERFACE_TYPE emMyItfType; 
	INTERFACE_TYPE emMyItfType2;

	emMyItfType2 = ITF_TYPE_USB_HID;
	CMSRItfUSBHID MSR(emMyItfType2);

	// Initiate all values
	for (i=0; i<BufferLength; i++)
		CardDataBuffer[i] = 0;

	// Scan for device interface
	for(m_ulDevIndex = 0; m_ulDevIndex <  20; m_ulDevIndex++)
	{
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{
					Sleep(50); // make sure the device is not busy

					MSR.SendCommand(datapool, outLength, CardDataBuffer, &BufferLength);
					isFound = true;

					break;
				}
			}
		}
	}
	
	if(!isFound)
	{
		emMyItfType2 = ITF_TYPE_USB_HID_KB;
		
		CMSRItfUSBHID MSR(emMyItfType2);

		for(m_ulDevIndex = 0; m_ulDevIndex <20; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{
						Sleep(200); // make sure the device is not busy.

						MSR.SendCommand(datapool, outLength, CardDataBuffer, &BufferLength);
						isFound = true;

						break;
					}
				}
			}
		}		
	}

	if(!isFound)
		MessageBox("Fail to detect device!", _T("Error"), MB_OK);

	if (CardDataBuffer[0] == 6)
		cmdSucceed = true;


	// Show command text
	StrResponse = _T("CMD: ");
	for (i=0; i<outLength; i++)
	{
		StrTmp.Format("%02X ", datapool[i]);
		StrResponse += StrTmp;
	}

	for (i=BufferLength; i>0; i--)
	{
		if (CardDataBuffer[i] != 0)
			break;
	} 
	int LastByte=i;

	// Output all response
	StrResponse += _T("\r\nOUT: ");
	if(CardDataBuffer[0]==0x06&&CardDataBuffer[1]!=0x02)
	{
		StrTmp.Format("%02X ",CardDataBuffer[0]);
			StrResponse += StrTmp;
		
	}
	else
	{
		for (i=0; i<LastByte; i++)
		{
			if(CardDataBuffer[i]==0x03)
			{
                int lrc=0;
				for(int k=1;k<=i;k++)
					lrc=lrc^CardDataBuffer[k];
				if(lrc==CardDataBuffer[i+1])
				{
				StrTmp.Format("%02X %02X ",CardDataBuffer[i],CardDataBuffer[i+1]);
				StrResponse += StrTmp;
				
				
				break;
				}
				else {
					StrTmp.Format("%02X ",CardDataBuffer[i]);
				StrResponse += StrTmp;
				}
				
			}
			else {
				StrTmp.Format("%02X ",CardDataBuffer[i]);
				StrResponse += StrTmp;
			
			}
	}

	}

	


	GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);

	MSR.CloseMSRDevice();

	return cmdSucceed;
}

/**************************************************/
/* Events of Main Menu - General Setting
/**************************************************/
void CKeyInjectModuleDlg::OnMENUSetDefault() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x18;
	datapool[3] = 0x03;
	datapool[4] = 0x4A;

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

void CKeyInjectModuleDlg::OnMENUReadConfiguration() 
{
	const int outLength = 5;
	BYTE datapool[outLength];
//	F_current = TRUE;
	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x1F;
	datapool[3] = 0x03;
	datapool[4] = 0x4C;

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

void CKeyInjectModuleDlg::OnMENUReadFirmware() 
{
	bool cmdSucceed;
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x22;
	datapool[3] = 0x03;
	datapool[4] = 0x71;

//	cmdSucceed = SendCommandRequest(datapool, outLength);
	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		cmdSucceed = SendCommandRequest(datapool, outLength);
	}

	if(cmdSucceed)
	{
		int i, j;
		CString StrResponse, StrTmp;
		
		// Get command request and response string
		GetDlgItem(IDC_RESP)->GetWindowText(StrResponse);

		// Get the end of card data
		for (i=BufferLength; i>0; i--)
			if (CardDataBuffer[i] != 0)
				break;

		// Append extra information
		StrResponse += "\r\nFirmware Version: ";
		for (j=2; j<i; j++)
		{
			StrTmp.Format("%C",CardDataBuffer[j]);
			StrResponse += StrTmp;
		}

		// Output with extra information
		GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	}
}

void CKeyInjectModuleDlg::OnMENUBeeperOff() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x11;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x72;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUBeeperLow() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x11;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x73;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUBeeperHigh() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x11;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x70;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMSREnableID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1A;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x78;

//	SendCommandRequest(datapool, outLength);
	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

void CKeyInjectModuleDlg::OnMSRDisableID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1A;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x79;

//	SendCommandRequest(datapool, outLength);
	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

void CKeyInjectModuleDlg::OnRawDataID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x7E;

//	SendCommandRequest(datapool, outLength);

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

void CKeyInjectModuleDlg::OnMENUReadBothDirections() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x7F;

//	SendCommandRequest(datapool, outLength);

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

void CKeyInjectModuleDlg::OnMENUReadForwardDirection() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x7C;

//	SendCommandRequest(datapool, outLength);

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

void CKeyInjectModuleDlg::OnMENUReadBackwardDirection() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x33;
	datapool[5] = 0x03;
	datapool[6] = 0x7D;

//	SendCommandRequest(datapool, outLength);

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

void CKeyInjectModuleDlg::OnSetPreamble0123456789ID() 
{
	const int outLength = 22;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0xD2;
	datapool[3] = 0x10;
	datapool[4] = 0x0f;
	datapool[5] = '0';
	datapool[6] = '1';
	datapool[7] = '2';
	datapool[8] = '3';
	datapool[9] = '4';
	datapool[10] = '5';
	datapool[11] = '6';
	datapool[12] = '7';
	datapool[13] = '8';
	datapool[14] = '9';
	datapool[15] = 'a';
	datapool[16] = 'b';
	datapool[17] = 'c';
	datapool[18] = 'd';
	datapool[19] = 'e';
	datapool[20] = 0x03;
	datapool[21] = 0xff;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnSetPostamble9876543210ID() 
{
	const int outLength = 22;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0xD3;
	datapool[3] = 0x10;
	datapool[4] = 0x0f;
	datapool[5] = 'e';
	datapool[6] = 'd';
	datapool[7] = 'c';
	datapool[8] = 'b';
	datapool[9] = 'a';
	datapool[10] = '9';
	datapool[11] = '8';
	datapool[12] = '7';
	datapool[13] = '6';
	datapool[14] = '5';
	datapool[15] = '4';
	datapool[16] = '3';
	datapool[17] = '2';
	datapool[18] = '1';
	datapool[19] = '0';
	datapool[20] = 0x03;
	datapool[21] = 0xfe;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetBufferMode() 
{
	// TODO: the result is not confirmed yet
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1A;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x7B;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMenuAtr() 
{
	// TODO: the result is not confirmed yet
	const int outLength = 6;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x50;
	datapool[2] = 0x01;
	datapool[3] = 0x30;
	datapool[4] = 0x03;
	datapool[5] = 0x60;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMENUReadBufferedData() 
{
	// TODO: the result is not confirmed yet
/*
	bool cmdSucceed;
	const int outLength = 6;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x51;
	datapool[2] = 0x01;
	datapool[3] = 0x30;
	datapool[4] = 0x03;
	datapool[5] = 0x61;

	cmdSucceed = SendCommandRequest(datapool, outLength);

	if(cmdSucceed)
	{
		int i, j;
		CString StrResponse, StrTmp;

		// Get command request and response string
		GetDlgItem(IDC_RESP)->GetWindowText(StrResponse);

		// Get the end of card data
		for (i=BufferLength; i>0; i--)
			if (CardDataBuffer[i] != 0)
				break;

		// Append extra information
		StrResponse += "\r\n\r\nBuffered Data: \r\n";

		if (!HIDMode)			// ID Tech USB HID Mode
		{
			for (j=11; j<i-1; j++)
			{
				StrTmp.Format("%C",CardDataBuffer[j]);
				StrResponse += StrTmp;
			}
		}
		else if (HIDMode == 2)	// MagTek USB HID Mode
		{
			for (j=9; j<i-1; j++)
			{
				StrTmp.Format("%C",CardDataBuffer[j]);
				StrResponse += StrTmp;
			}
		}

		// Output with extra information
		GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	}
*/

	INTERFACE_TYPE emMyItfType; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName,StrResponse,StrTmp;
	int		m_ulDevIndex = 0;
	BYTE BufferTmp[500];
	ULONG	BufferLength = 500;
	int i, j;

	emMyItfType2 = ITF_TYPE_USB_HID;

	CMSRItfUSBHID	MSR(emMyItfType2);

	for (i=0; i<500; i++)
		BufferTmp[i] = 0;

	BYTE datapool[6];
	datapool[0] = 0x02;
	datapool[1] = 0x51;
	datapool[2] = 0x01;
	datapool[3] = 0x30;
	datapool[4] = 0x03;
	datapool[5] = 0x61;
	int outLength = 6;

	for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
	{
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)			
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{
					Sleep(50); // make sure the device is not busy.
					MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
				}
			}
		}
	}
	if(m_ulDevIndex >= 10){
	  emMyItfType2 = ITF_TYPE_USB_HID_KB;

	  CMSRItfUSBHID	MSR(emMyItfType2);
	  for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
	  {
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{
					Sleep(50); // make sure the device is not busy.
					MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
				}
			}
		}
	  }		
	}
//	if ( BufferTmp[0] == 6)
//		MessageBox("Read Buffered Data command was sent successfully!","Status",MB_OK);				
//	else
//		MessageBox("Fail to Read Buffered Data!",_T("Error"),MB_OK);				
	
	for (i=BufferLength; i>0; i--)
		if (BufferTmp[i] != 0)
			break;

	if (( BufferTmp[0] == 6) || ( BufferTmp[0] == 21))
		for (j=0; j<i+1; j++)
		{
			StrTmp.Format("%02X ",BufferTmp[j]);
			StrResponse += StrTmp;
		}

	if (( BufferTmp[0] == 6) && ( i > 3))
	{
		StrResponse += "\r\n\r\nBuffered Data: \r\n";

		if (!HIDMode)	// ID Tech USB HID Mode
			for (j=11; j<i-1; j++)
			{
				StrTmp.Format("%C",BufferTmp[j]);
				StrResponse += StrTmp;
			}
		else if (HIDMode == 2)	// MagTek USB HID Mode
			for (j=9; j<i-1; j++)
			{
				StrTmp.Format("%C",BufferTmp[j]);
				StrResponse += StrTmp;
			}
	}

	//Show command text
	StrResponse = "CMD: 02 51 01 30 03 61\r\nOUT: " + StrResponse;
	GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	MSR.CloseMSRDevice();					

}

void CKeyInjectModuleDlg::OnHIDMagTMode() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x23;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x41;

	cmdSucceed = SendCommandRequest(datapool, outLength);

//	if(cmdSucceed)
		HIDMode = 2;	// MagTek USB HID Mode

//	GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
}

void CKeyInjectModuleDlg::OnHIDIDTMode() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x23;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x40;

	cmdSucceed = SendCommandRequest(datapool, outLength);

//	if(cmdSucceed)
		HIDMode = 0;	// ID Tech USB HID Mode

//	GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);

//	GetDlgItem(IDC_STATIC_FLAG)->ShowWindow(SW_HIDE);

	GetDlgItem(IDC_STATIC_HID)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_STATIC_USBKB)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATIC_BT)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_BUTTON_CONNECT)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_BUTTON_REFRESH)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_COMBO_COM)->ShowWindow(SW_HIDE);
}

void CKeyInjectModuleDlg::OnUSBKBMode() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x23;
	datapool[3] = 0x01;
	datapool[4] = 0x38;
	datapool[5] = 0x03;
	datapool[6] = 0x48;

	cmdSucceed = SendCommandRequest(datapool, outLength);

//	if(cmdSucceed)
		HIDMode = 1;	// ID Tech USB HID KB Mode

//	GetDlgItem(IDC_STATIC_FLAG)->ShowWindow(SW_HIDE);

	GetDlgItem(IDC_STATIC_HID)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATIC_USBKB)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_STATIC_BT)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_BUTTON_CONNECT)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_BUTTON_REFRESH)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_COMBO_COM)->ShowWindow(SW_HIDE);
}


/**************************************************/
/* Events of Main Menu - Track Setting
/**************************************************/
void CKeyInjectModuleDlg::OnMENUReadAnyTracks() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x70;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMENUReadTrack1() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x71;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMENUReadTrack2() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x72;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadTrack12() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x33;
	datapool[5] = 0x03;
	datapool[6] = 0x73;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadTrack3() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x34;
	datapool[5] = 0x03;
	datapool[6] = 0x74;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadTrack13() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x35;
	datapool[5] = 0x03;
	datapool[6] = 0x75;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadTrack23() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x36;
	datapool[5] = 0x03;
	datapool[6] = 0x76;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadAllTracks() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x37;
	datapool[5] = 0x03;
	datapool[6] = 0x77;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSendTrackSeparator() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x17;
	datapool[3] = 0x01;
	datapool[4] = 0x0D;
	datapool[5] = 0x03;
	datapool[6] = 0x49;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUNotSendTrackSeparator() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x17;
	datapool[3] = 0x01;
	datapool[4] = 0x00;
	datapool[5] = 0x03;
	datapool[6] = 0x44;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSendTerminator() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x21;
	datapool[3] = 0x01;
	datapool[4] = 0x0D;
	datapool[5] = 0x03;
	datapool[6] = 0x7F;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUNotSendTerminator() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x21;
	datapool[3] = 0x01;
	datapool[4] = 0x00;
	datapool[5] = 0x03;
	datapool[6] = 0x72;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnEnableLRCID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x60;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x02;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnDisableLRCID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x60;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x03;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnWSEErrorNotificationID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x19;
	datapool[3] = 0x01;
	datapool[4] = 0x35;
	datapool[5] = 0x03;
	datapool[6] = 0x7F;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnWoSEAllT2ErrorNotification() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x19;
	datapool[3] = 0x01;
	datapool[4] = 0x34;
	datapool[5] = 0x03;
	datapool[6] = 0x7E;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnWSEPartialT2ErrorNotification() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x19;
	datapool[3] = 0x01;
	datapool[4] = 0x37;
	datapool[5] = 0x03;
	datapool[6] = 0x7D;

	SendCommandRequest(datapool, outLength);
}


/**************************************************/
/* Events of Main Menu - MSR Security
/**************************************************/
void CKeyInjectModuleDlg::OnMENUSetPrePANClrDataID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x49;
	datapool[3] = 0x01;
	datapool[4] = 0x06;
	datapool[5] = 0x03;
	datapool[6] = 0x1C;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetPostPANClrDataID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4A;
	datapool[3] = 0x01;
	datapool[4] = 0x03;
	datapool[5] = 0x03;
	datapool[6] = 0x1A;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetMaskCharID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4B;
	datapool[3] = 0x01;
	datapool[4] = 0x23;
	datapool[5] = 0x03;
	datapool[6] = 0x3B;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnSecurityLevID() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x7E;
	datapool[3] = 0x03;
	datapool[4] = 0x2D;

//	SendCommandRequest(datapool, outLength);

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

void CKeyInjectModuleDlg::OnGetDeviceSN() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x4e;
	datapool[3] = 0x03;
	datapool[4] = 0x1d;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnSetDeviceSN() 
{
	bool cmdSucceed;
	const int outLength = 15;
	BYTE datapool[outLength];

	CFile fSN;
	CFileException ex;
	CString	StrBuff;
	BYTE LRC=0;

	// Read SN from file
	if(fSN.Open(".\\SN.txt", CFile::modeRead, &ex))		
	{
		int len = fSN.GetLength();
		TCHAR *SNData = new TCHAR[len + 1];
		SNData[len] = '\0';
		fSN.Read(SNData, len);
		CString szBuff(SNData);
		
		StrBuff = szBuff;
		fSN.Close();
	}
	else
	{
		StrBuff = _T("00000001");
	}


	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4e;
	datapool[3] = 0x09;
	datapool[4] = 0x08;

	for (int i=0; i<8; i++)
		datapool[i+5] = StrBuff.GetAt(i);

	datapool[13] = 0x03;
	
	for (i=0; i<14; i++)
		LRC ^= datapool[i];
	
	datapool[14] = LRC;
	
	
	cmdSucceed = SendCommandRequest(datapool, outLength);

	if(cmdSucceed)
	{
		MessageBox("Set Device SN command was sent successfully!","Status",MB_OK);
		
		fSN.Remove(".\\SN.txt");
		
		long SerialNo = atoi(StrBuff);
		SerialNo+=1;	
		StrBuff.Format("%08ld",SerialNo);
		
		// Update the new serial number and write it to the file
		if(fSN.Open(".\\SN.txt", CFile::modeWrite|CFile::modeCreate, &ex))
			fSN.Write(StrBuff, 8);
		
		fSN.Close();
	}
	else
	{
		MessageBox("Fail to Set Device SN!",_T("Error"),MB_OK);
	}
}

void CKeyInjectModuleDlg::OnMenuTdes() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x2E;

//	cmdSucceed = SendCommandRequest(datapool, outLength);
	//Open bluetooth ??
	if (IsOpen==1)
	{
		cmdSucceed = SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		cmdSucceed = SendCommandRequest(datapool, outLength);
	}

	if(cmdSucceed)
		bDecryptMode = 1;	// DES Mode
}

void CKeyInjectModuleDlg::OnMenuAes() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x2D;
	
//	cmdSucceed = SendCommandRequest(datapool, outLength);

	//Open bluetooth ??
	if (IsOpen==1)
	{
		cmdSucceed = SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		cmdSucceed = SendCommandRequest(datapool, outLength);
	}

	if(cmdSucceed)
		bDecryptMode = 2;	// AES mode
}

void CKeyInjectModuleDlg::OnMENUSetSessionID() 
{
	// TODO: the result is not confirmed yet
	const int outLength = 14;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x54;
	datapool[3] = 0x08;
	datapool[4] = 0x55;
	datapool[5] = 0x55;
	datapool[6] = 0x55;
	datapool[7] = 0x55;
	datapool[8] = 0x55;
	datapool[9] = 0x55;
	datapool[10] = 0x55;
	datapool[11] = 0x55;
	datapool[12] = 0x03;
	datapool[13] = 0x0E;
	
	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMenuEnableencryption() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x2E;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMenuDisableencryption() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x2F;

	SendCommandRequest(datapool, outLength);
}


/**************************************************/
/* Events of Main Menu - USB KB Setting
/**************************************************/
void CKeyInjectModuleDlg::OnSetpollinginterval1() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x14;
	datapool[3] = 0x01;
	datapool[4] = 0x01;
	datapool[5] = 0x03;
	datapool[6] = 0x46;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetPollingInterval() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x14;
	datapool[3] = 0x01;
	datapool[4] = 0x0a;
	datapool[5] = 0x03;
	datapool[6] = 0x4d;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetArabia() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x24;
	datapool[3] = 0x01;
	datapool[4] = 0x3d;
	datapool[5] = 0x03;
	datapool[6] = 0x4A;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetUK() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x24;
	datapool[3] = 0x01;
	datapool[4] = 0x39;
	datapool[5] = 0x03;
	datapool[6] = 0x4E;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetUniversal() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x24;
	datapool[3] = 0x01;
	datapool[4] = 0x3a;
	datapool[5] = 0x03;
	datapool[6] = 0x4d;

	SendCommandRequest(datapool, outLength);
}


/**************************************************/
/* Events of Main Menu - Firmware Upgrade
/**************************************************/
void CKeyInjectModuleDlg::OnEnterBootloaderModeID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x70;
	datapool[3] = 0x01;
	datapool[4] = 0xFF;
	datapool[5] = 0x03;
	datapool[6] = 0xDC;

	SendCommandRequest(datapool, outLength);
}


/**************************************************/
/* Events of Main Menu - Help
/**************************************************/
void CKeyInjectModuleDlg::OnMENUAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();		
}

void CKeyInjectModuleDlg::OnActivateAuthentication() 
{
	// TODO: the result is not confirmed yet
	CDES		lcDES;
	CDUKPT		lcDUKPT;
	AesCipher	lcAES;
	CString		StrTmp,StrOut;

	BYTE KSNTmp[10];
	BYTE KeyTmp[16];
	BYTE keyt[16];
	BYTE XORKey = 240; // F0
	BOOL bError = false;
	KillTimer(2);
	GetDlgItem(IDC_EDIT1)->SetWindowText("60");
	unsigned long counter;
	unsigned char stringKSN[10];
	unsigned char  k=1;

	const int outLength = 8;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x80;
	datapool[3] = 0x02;
	datapool[4] = 0x00;
	datapool[5] = 0x00;
	datapool[6] = 0x03;
	datapool[7] = 0xD1;

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}

//	SendCommandRequest(datapool, outLength);


	// Check KSN from response
	for(int i=0; i<10; i++) {
		KSNTmp[i] = CardDataBuffer[2 + i]; // skip first 2 bytes
		KSNglb[i] = KSNTmp[i];
	}

	// Update challenge
	for(i=0; i<16; i++)
		challenge[i] = CardDataBuffer[12 + i]; // skip first 2+10 bytes


	for(i=0; i<16; i++)
		keyt[i] = CardDataBuffer[12 + i]; // skip first 2+10 bytes

//@@@ Need to decrypt the 16 bytes to get challeng1 and challeng2. Using TDES CBC.

	//Initial key
	if (!bIK)
	{
		m_str_initial_key = StrInitialKey;
		int len = m_str_initial_key.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
	}


	memcpy(stringKSN, KSNTmp,10);

	//calculate the counter
	counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
	stringKSN[9] = stringKSN[8] = 0;
	stringKSN[7] &= 0xE0;

	GetIK(stringKSN, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);

	//get the m_cryptoKey
	memset(m_cryptoKey, 0, 16);
	lcDUKPT.IDT_LoadInitKey(1, m_ninitial_key, stringKSN);
	
	do
	{	       
	   lcDUKPT.IDT_EncryptPIN(m_des_index,
							  lcDUKPT.IDT_ChangeCounter(counter, k),
							  stringKSN,            // returns the 10-byte KSN
							  m_cryptoKey,
							  0); 
	   k++;
	}while(k <= lcDUKPT.IDT_GetNumOfOnes(counter));

	for (i=0; i<16; i++)
		KeyTmp[i] = m_cryptoKey[i]^XORKey;

	if (bDecryptMode == 1) //TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};

		lcDES.des_cbc_decryption(1, challenge, KeyTmp, init_vector, (INT16U)((16) >> 3));
	}

	else //if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

		lcAES.setIV(init_vector);
		lcAES.makeRoundKey(KeyTmp, DEFAULT_KEY_LENGTH);
		lcAES.decryptString(challenge, challenge, 16, CBC);
	}	

// @@@ Need to verify the last 2 bytes of Challenge 1 is the last 2 bytes of KSN
	for (i=8; i<10; i++)
	{
		if (KSNTmp[i] != challenge[i-2])
		{
			MessageBox("KSN does not match!");
			break;
		}
	}
}

void CKeyInjectModuleDlg::OnActivateChallengeReply() 
{
	// TODO: the result is not confirmed yet
	CDES		lcDES;
	CDUKPT		lcDUKPT;
	AesCipher	lcAES;
	BYTE KSNTmp[10];
	BYTE DataTmp[32];
	BYTE KeyTmp[16];
	BYTE LRC = 0;
	BYTE XORKey = 60; // 3C
	unsigned long counter;
	unsigned char stringKSN[10];
	unsigned char  k=1;
	const int outLength = 22;
	BYTE datapool[outLength];
	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x82;
	datapool[3] = 0x10;
	CString strx;
	GetDlgItem(IDC_EDIT1)->GetWindowText(strx);
	GetDlgItem(IDC_EDIT1)->GetWindowText(strtt);
	GetDlgItem(IDC_COMMAND)->GetWindowText(cmd);
	int ss=atoi(strx);

	// 6-byte challenge 1
	for(int i=0; i<6; i++)
		DataTmp[i] = challenge[i];
	// 2-byte time information
	DataTmp[6] = 0x00;
	//DataTmp[7] = 0x3C; // 60 seconds
	DataTmp[7] = byte(ss); 
	SetTimer(2,1000,NULL);

	// Check KSN from response
//	KSNglb[9]++;
	for(i=0; i<10; i++) {
		KSNTmp[i] = KSNglb[i];
	}

	//Initial key
	if (!bIK)
	{
		m_str_initial_key = StrInitialKey;
		int len = m_str_initial_key.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
	}
	memcpy(stringKSN, KSNTmp,10);
	//calculate the counter
	counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
	stringKSN[9] = stringKSN[8] = 0;
	stringKSN[7] &= 0xE0;
	GetIK(stringKSN, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);
	//get the m_cryptoKey
	memset(m_cryptoKey, 0, 16);
    lcDUKPT.IDT_LoadInitKey(1, m_ninitial_key, stringKSN);
	do
	{	       
	   lcDUKPT.IDT_EncryptPIN(m_des_index,
							  lcDUKPT.IDT_ChangeCounter(counter, k),
							  stringKSN,            // returns the 10-byte KSN
							  m_cryptoKey,
							  0); 
	   k++;
	}while(k <= lcDUKPT.IDT_GetNumOfOnes(counter));
	// challenge
	for(i=8; i<16; i++)
		DataTmp[i] = 0xAA;
	// XOR Key
	for(i=0; i<16; i++)
		KeyTmp[i] = XORKey ^ m_cryptoKey[i];	
	if (bDecryptMode == 1)	//TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};

		lcDES.des_cbc_encryption(1, DataTmp, KeyTmp, init_vector, (INT16U)((16) >> 3));
	}
	else //if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

		lcAES.setIV(init_vector);
		lcAES.makeRoundKey(KeyTmp, DEFAULT_KEY_LENGTH);
		lcAES.encryptString(DataTmp, DataTmp, 16, CBC);
	}
	// Encrypted Challenge 
	for(i=0; i<16; i++)
		datapool[4 + i] = DataTmp[i];
	datapool[20] = 0x03;
	// calculate LRC
	for (i=0; i<21; i++)
		LRC ^= datapool[i];
	datapool[21] = LRC;
	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
//	SendCommandRequest(datapool, outLength);
//	if (asctohex(StrResponse.GetAt(0),StrResponse.GetAt(1)) == 6)
		bActivation = true;
}

void CKeyInjectModuleDlg::OnDeactivateChallengeReply() 
{
	BYTE KSNTmp[10];
	BYTE DataTmp_TDES[16];
	BYTE DataTmp_AES[16];
	BYTE KeyTmp[16];
	BYTE LRC;
	BYTE XORKey = 60; // 3C
	unsigned char  k=1;
	unsigned long   counter;
	unsigned char  stringKSN[10];
	int i;
	BYTE datapool_TDES[14];
	BYTE datapool_AES[22];

	KillTimer(2);
	GetDlgItem(IDC_EDIT1)->SetWindowText("60");

	if (bDecryptMode == 1)	//TDES
	{
		datapool_TDES[0] = 0x02;
		datapool_TDES[1] = 0x53;
		datapool_TDES[2] = 0x81;
		datapool_TDES[3] = 0x08;
		// 6-byte challenge 1
		for(i=0; i<7; i++)
			DataTmp_TDES[i] = challenge[8 + i];
		// 2-byte time information
		DataTmp_TDES[7] = 0x01;
	}
	else					//AES
	{
		datapool_AES[0] = 0x02;
		datapool_AES[1] = 0x53;
		datapool_AES[2] = 0x81;
		datapool_AES[3] = 0x10;
		// 6-byte challenge 1
		for(i=0; i<7; i++)
			DataTmp_AES[i] = challenge[8 + i];
		// 2-byte time information
		DataTmp_AES[7] = 0x01;
		for(i=8; i<15; i++)
			DataTmp_AES[i] = 0;
	}

	// Check KSN from response
//	KSNglb[9]++;
	for(i=0; i<10; i++) {
		KSNTmp[i] = KSNglb[i];
	}

	//Initial key
	if (!bIK)
	{
		m_str_initial_key = StrInitialKey;
		int len = m_str_initial_key.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
	}


	memcpy(stringKSN, KSNTmp,10);

	//calculate the counter
	counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
	stringKSN[9] = stringKSN[8] = 0;
	stringKSN[7] &= 0xE0;
 
	GetIK(stringKSN, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);

	//get the m_cryptoKey
	memset(m_cryptoKey, 0, 16);
    lcDUKPT.IDT_LoadInitKey(1, m_ninitial_key, stringKSN);

	do
	{	       
	   lcDUKPT.IDT_EncryptPIN(m_des_index,
							  lcDUKPT.IDT_ChangeCounter(counter, k),
							  stringKSN,            // returns the 10-byte KSN
							  m_cryptoKey,
							  0); 
	   k++;
	}while(k <= lcDUKPT.IDT_GetNumOfOnes(counter));


	// XOR Key
	for(i=0; i<16; i++)
		KeyTmp[i] = XORKey ^ m_cryptoKey[i];


	if (bDecryptMode == 1)	//TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};

		lcDES.des_cbc_encryption(1, DataTmp_TDES, KeyTmp, init_vector, (INT16U)((16) >> 3));
		for(i=0; i<8; i++)
			datapool_TDES[4 + i] = DataTmp_TDES[i];

		datapool_TDES[12] = 0x03;

		LRC = 0;
		// calculate LRC
		for (i=0; i<13; i++)
			LRC ^= datapool_TDES[i];

		datapool_TDES[13] = LRC;

		//Open bluetooth ??
		if (IsOpen==1)
		{
			SendBluetoothCommand(datapool_TDES, 14);
		}
		else
		{
			SendCommandRequest(datapool_TDES, 14);
		}
	//	SendCommandRequest(datapool_TDES, 14);
	}	
	else //if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		lcAES.setIV(init_vector);
		lcAES.makeRoundKey(KeyTmp, DEFAULT_KEY_LENGTH);
		lcAES.encryptString(DataTmp_AES, DataTmp_AES, 16, CBC);
	
		for(i=0; i<16; i++)
			datapool_AES[4 + i] = DataTmp_AES[i];

		datapool_AES[20] = 0x03;

		LRC = 0;
		// calculate LRC
		for (i=0; i<21; i++)
			LRC ^= datapool_AES[i];

		datapool_AES[21] = LRC;

		//Open bluetooth ??
		if (IsOpen==1)
		{
			SendBluetoothCommand(datapool_AES, 22);
		}
		else
		{
			SendCommandRequest(datapool_AES,22);
		}
//		SendCommandRequest(datapool_AES, 22);
	}	
//	if (asctohex(StrResponse.GetAt(0),StrResponse.GetAt(1)) == 6)
		bActivation = false;
}

void CKeyInjectModuleDlg::OnGetReaderStatus() 
{
	// TODO: the result is not confirmed yet
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x83;
	datapool[3] = 0x03;
	datapool[4] = 0xD0;

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}

//	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUNewEncryptionFormat() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x85;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0xE7;

	SendCommandRequest(datapool, outLength);			
}

void CKeyInjectModuleDlg::OnMENUOldEncryptionFormat() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x85;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0xE6;

	SendCommandRequest(datapool, outLength);		
}

void CKeyInjectModuleDlg::OnMENUForceEncryptAllTracks() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x84;
	datapool[3] = 0x01;
	datapool[4] = 0x07;
	datapool[5] = 0x03;
	datapool[6] = 0xD0;

	SendCommandRequest(datapool, outLength);		
}

void CKeyInjectModuleDlg::OnMENUClear() 
{
	// TODO: Add your command handler code here
	GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
	GetDlgItem(IDC_COMMAND)->SetFocus();
}

void CKeyInjectModuleDlg::OnMENUClear2() 
{
	// TODO: Add your command handler code here
	GetDlgItem(IDC_RESP)->SetWindowText(_T(""));
	GetDlgItem(IDC_RESP)->SetFocus();
}

void CKeyInjectModuleDlg::OnGetKSN() 
{
	// TODO: Add your command handler code here
	const int outLength = 5;
	BYTE datapool[outLength]; 
	
	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x51;
	datapool[3] = 0x03;
	datapool[4] = 0x02;
	
//	SendCommandRequest(datapool, outLength);

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}
/*
void CKeyInjectModuleDlg::OnMENUEnEncryp() 
{
	// TODO: Add your command handler code here
	const int outLength = 5;
	BYTE datapool[outLength];
	
	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x51;
	datapool[3] = 0x03;
	datapool[4] = 0x02;
	
	SendCommandRequest(datapool, outLength);
}
*/
void CKeyInjectModuleDlg::OnMENUDisEncryp() 
{
	// TODO: Add your command handler code here
//	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];
	
	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x2F;
	
//	SendCommandRequest(datapool, outLength);

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
	
	//	if(cmdSucceed)
	//	bDecryptMode = 0;	// no encryption mode
}

void CKeyInjectModuleDlg::OnMenuSetfixedKey() 
{
	// TODO: Add your command handler code here
	const int outLength = 7;
	BYTE datapool[outLength];
	
	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x58;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x3B;
	
//	SendCommandRequest(datapool, outLength);

	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

void CKeyInjectModuleDlg::OnMenuSetdupkt() 
{
	// TODO: Add your command handler code here
	const int outLength = 7;
	BYTE datapool[outLength];
	
	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x58;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x3A;
	
//	SendCommandRequest(datapool, outLength);
	
	//Open bluetooth ??
	if (IsOpen==1)
	{
		SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		SendCommandRequest(datapool, outLength);
	}
}

//Get encrypted challenge
void CKeyInjectModuleDlg::OnMENUCHAllenge() 
{
	// TODO: Add your command handler code here
	bool cmdSucceed;
	const int outLength = 5;
	BYTE datapool[outLength];
	
	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x74;
	datapool[3] = 0x03;
	datapool[4] = 0x27;
	
//	cmdSucceed = SendCommandRequest(datapool, outLength);
	//Open bluetooth ??
	if (IsOpen==1)
	{
		cmdSucceed = SendBluetoothCommand(datapool, outLength);
	}
	else
	{
		cmdSucceed = SendCommandRequest(datapool, outLength);
	}
	
	if(cmdSucceed)
	{
		CString StrResponse,StrTmp;

		// Get command request and response string
		GetDlgItemText(IDC_RESP,StrResponse);
		StrTmp=StrResponse;

		StrTmp.Remove(_T(' ')); //remove space
		StrTmp.Remove(_T('\t')); //remove tab
		StrTmp.Remove(_T('\r')); //remove CR
		StrTmp.Remove(_T('\n')); //remove new line

		int DataPos = StrTmp.Find("0602");
		StrTmp = StrTmp.Mid(DataPos+4, 16);

		int nSize = StrTmp.GetLength();

		// Convert the command to hex formart
		MakeCommand(StrTmp, EncryptedData, &nSize);

		//Show decrypted text
		for (int i=0; i<8; i++)
		{
			StrTmp.Format("%02X ", EncryptedData[i]);
			StrResponse += StrTmp;
		}

		bGetChallenge = true;
	}
}


//Send authentication data
void CKeyInjectModuleDlg::OnMenuAuthent() 
{
	// TODO: Add your command handler code here
	bool cmdSucceed;
	CString StrTmp;
	int LRC=0;
	BOOL bNewKey = false;
	CDES lcDES;
	BYTE DuplicatedEncryptedData[8];

	if (bGetChallenge)
	{
		int i;
		for (i=0; i<8; i++)
		DuplicatedEncryptedData[i] = EncryptedData[i];

		bNewKey = MessageBox("Load New Key for Authentication?",NULL, MB_YESNO);

		// Apply new key
		if (bNewKey == 6)//IDYES
		{
			int iReturnStatus=0;
		
			m_KetRtrvr.m_sCaption = "INPUT KEY";
			m_KetRtrvr.m_strLabel = "Key";
			m_KetRtrvr.m_cPasswordChar = 0;
			m_KetRtrvr.m_strCaption = "";

			byte* pKey = NULL;
			pKey =(byte*)malloc(sizeof(byte) * 16);

			for(int j=0;j<1;j++)
			{
				iReturnStatus = Getkey(32,pKey);
				if( (iReturnStatus == 2) || (iReturnStatus == 1) )
				{
					--j;
					continue;
				}
				else if(iReturnStatus == 3)
				{
					return;
				}
			}

			for (i=0; i<16; i++)
			MagTekKey[i] = pKey[i];

			lcDES.DEA_decryption(1, DuplicatedEncryptedData, pKey);   //TDES decryption

			free(pKey);	
		}

		// Default Key
		else
		{
			BYTE key[16];
		
			for (int i=0; i<16; i++)	
				key[i] = 0;
		
			lcDES.DEA_decryption(1, DuplicatedEncryptedData, key);   //TDES decryption
		}
		

		BYTE datapool[14];
		// SPI Envelope
		datapool[0] = 0x02;
		datapool[1] = 0x53;
		datapool[2] = 0x74;
		datapool[3] = 0x08;
		// Decrypted Data from Challenge 
		for (i=4; i<12; i++)
			datapool[i] = DuplicatedEncryptedData[i-4];
		datapool[12] = 0x03;	// ETX in SPI Envelope
		for (i=0; i<13; i++)
			LRC ^= datapool[i];	
		datapool[13] = LRC;		// LRC in SPI Envelope

        int outLength = 14;

	//	cmdSucceed = SendCommandRequest(datapool, outLength);

		//Open bluetooth ??
		if (IsOpen==1)
		{
			cmdSucceed = SendBluetoothCommand(datapool, outLength);
		}
		else
		{
			cmdSucceed = SendCommandRequest(datapool, outLength);
		}

		if (cmdSucceed)
		{
			bAuthentication = TRUE;
		}
	}
	else	
		MessageBox("Please Send Retrieve Challenge Command!"); 	

  }

//Load fixed key
void CKeyInjectModuleDlg::OnMenuLoadkey() 
{
	// TODO: Add your command handler code here
	CString StrTmp;
	int LRC=0;
	
	if (bAuthentication)
	{
		m_KetRtrvr.m_sCaption = "INPUT KEY (OTHER ENCRYPTION)";
		m_KetRtrvr.m_strLabel = "Key";
		m_KetRtrvr.m_cPasswordChar = 0;
		m_KetRtrvr.m_strCaption = "";
		
		int i=0;
		int iReturnStatus=0;
		
		byte* pkey = NULL;
		pkey =(byte*)malloc(sizeof(byte) * 16);
		
		for(int j=0;j<1;j++)
		{
			iReturnStatus = Getkey(32,pkey);
			if( (iReturnStatus == 2) || (iReturnStatus == 1) )
			{
				--j;
				continue;
			}
			else if(iReturnStatus == 3)
			{
				return;
			}
		}
		
		for (i=0; i<16; i++)
			MagTekKey[i] = pkey[i];
		
		free(pkey);	
		
		BYTE datapool[22];

		// SPI Envelope
		datapool[0] = 0x02;
		datapool[1] = 0x53;
		datapool[2] = 0x76;
		datapool[3] = 0x10;
		for (i=4; i<20; i++)
			datapool[i]= MagTekKey[i-4];
		datapool[20] = 0x03;	// ETX in SPI Envelope
		for (i=0; i<21; i++)
			LRC ^= datapool[i];	
		datapool[21] = LRC;		// LRC in SPI Envelope
		int outLength = 22;

//		SendCommandRequest(datapool, outLength);

		//Open bluetooth ??
		if (IsOpen==1)
		{
			SendBluetoothCommand(datapool, outLength);
		}
		else
		{
			SendCommandRequest(datapool, outLength);
		}
	}
	else
		MessageBox("Please Send Authentication Command!");
}

void CKeyInjectModuleDlg::OnMENUBluetooth() 
{
	// TODO: Add your command handler code here
/*	OnButtonRefresh();
	Sleep(1000);
	HANDLE hHND;
	hHND = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)DevThread,this,0,NULL);
	CloseHandle(hHND);
*/
//	GetDlgItem(IDC_STATIC_FLAG)->ShowWindow(SW_HIDE);

	GetDlgItem(IDC_STATIC_HID)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATIC_USBKB)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATIC_BT)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_BUTTON_CONNECT)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_BUTTON_REFRESH)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_COMBO_COM)->ShowWindow(SW_SHOW);
}

void CKeyInjectModuleDlg::OnButtonRefresh() 
{
	// TODO: Add your control notification handler code here
	long ret;
	HKEY hkey;
	CString KeyPos;
	WCHAR portName[128],commName[128], name[128]=L"\\Device\\BthModem",name2[128]=L"\\Device\\",name3[128]=L"\\Device\\Serial";
	int index;
	int De_index = 0;
	DWORD dwlong,dwsize;
	BOOL F_device = FALSE;
	
	KeyPos.Format(_T("HARDWARE\\DEVICEMAP\\SERIALCOMM"));
	ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE,KeyPos,NULL,KEY_READ,&hkey);
	m_ComboDev.ResetContent();
//	m_ComboDev.AddString("COM1");
//	m_ComboDev.AddString("COM2");
	if (ret == ERROR_SUCCESS)
	{
		for (index=0;; index++)
		{
			dwsize = sizeof(portName);
			dwlong = dwsize;
			ret = RegEnumValueW(hkey,index,(LPWSTR)portName,&dwlong,NULL,NULL,(LPBYTE)commName,&dwsize);
			if (ret == ERROR_NO_MORE_ITEMS ) 
				break;
			int res = wcsncmp(portName,name3,13);
			if (res == 0) 
				continue;
			res = wcsncmp(portName,name2,6);
			if ( res == 0 )
			{
				CString strTmp = L"\\\\.\\" + (CString)commName;
				if (TestComport(strTmp)==TRUE)
				{
					F_device = TRUE;
					DEVICE[De_index].name = portName;
					DEVICE[De_index].port = L"\\\\.\\" + (CString)commName;
					DEVICE[De_index].status = 0;
					m_ComboDev.AddString((CString)commName);
					De_index ++;
				}
			}
		}
	}
	if (!F_device)
	{
		AfxMessageBox("No device found. Please check the device is paired.");
	}
	RegCloseKey(hkey);
	m_ComboDev.SetCurSel(0);
	count_search= De_index;
//	OnButtonConnect();
}

BOOL CKeyInjectModuleDlg::TestComport(LPCTSTR Port)
{
	BYTE cmd[128];
	BYTE rec[128];
	int cmdlen;
	cmd[0] = 0x02;
	cmd[1] = 0x52;
	cmd[2] = 0x22;
	cmd[3] = 0x03;
	cmd[4] = 0x71;
	cmdlen = 5;
	Device.Open(Port);
	bool res = (Device.Write(cmd,cmdlen,2000)!=0);
	if (res)
	{
		for(int i=0;i<20;i++)
		{
			Sleep(50);
		Device.Read(rec,128,2000);
		if (rec[0]== 0x06)
		{	res = true;
		    Device.Close();
		    return res;
		}
		}
	
	}
		res=false;
	Device.Close();
	return res;
}

BOOL CKeyInjectModuleDlg::SendBluetoothCommand(byte *datapool, int outLength)
{
	CString StrResponse, StrTmp;
	ULONG ReceiveBluetoothLength;
	int i, j;
	bool cmdSucceed = false;

if (!IsCardSend)
{
	Device.Read(CardDataBuffer,BufferLength,3000);
	for (i=0; i<BufferLength; i++)
		CardDataBuffer[i] = 0;


	bool res = (Device.Write(datapool,outLength,3000)!=0);
	IsSend=TRUE;


	if (res)
	{
		// Initiate all values
		for(i=0;i<50;i++)
		{
               Sleep(20);
	
			ReceiveBluetoothLength=Device.Read(CardDataBuffer,BufferLength,3000);
			if(ReceiveBluetoothLength>0)
				break;

		}
	}

	if (CardDataBuffer[0] == 6)
		cmdSucceed = true;

	// Show command text
	StrResponse = ("CMD: ");
	for (i=0; i<outLength; i++)
	{
		StrTmp.Format("%02X ", datapool[i]);
		StrResponse += StrTmp;
	}
	for (i=ReceiveBluetoothLength; i>0; i--)
	{
		if (CardDataBuffer[i] != 0)
			break;
	}
    
	int LastByte=i;
	
	// Output all response
	StrResponse += _T("\r\nOUT: ");
	if(CardDataBuffer[0]==0x06&&CardDataBuffer[1]!=0x02)
	{
		StrTmp.Format("%02X ",CardDataBuffer[0]);
		StrResponse += StrTmp;
		
	}
	else
	{
		for (i=0; i<LastByte; i++)
		{
			if(CardDataBuffer[i]==0x03)
			{
                int lrc=0;
				for(int k=1;k<=i;k++)
					lrc=lrc^CardDataBuffer[k];
				if(lrc==CardDataBuffer[i+1])
				{
					StrTmp.Format("%02X %02X ",CardDataBuffer[i],CardDataBuffer[i+1]);
					StrResponse += StrTmp;
					
					
					break;
				}
				else {
					StrTmp.Format("%02X ",CardDataBuffer[i]);
					StrResponse += StrTmp;
				}
				
			}
			else {
				StrTmp.Format("%02X ",CardDataBuffer[i]);
				StrResponse += StrTmp;
				
			}
	}
	}

	GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	IsSend=FALSE;
}
	return cmdSucceed;
}


void DevThread(CKeyInjectModuleDlg * pDlg)
{
	while (pDlg->IsOpen)
	{
		if(!(pDlg->IsSend))
		{
			BYTE Buffer[1000];
			CString StrCardData;
			CString StrTmp;
			DWORD r,rr;
			int Lrc=0;

			r = pDlg->Device.Read(Buffer, sizeof(Buffer) -1,1000);
			pDlg->IsCardSend = FALSE;
            if((r==5&&Buffer[0]==0x02&&Buffer[1]==0x45&&Buffer[2]==0x49&&Buffer[3]==0x03&&Buffer[4]==0x0d)||(r==10&&Buffer[5]==0x02&&Buffer[6]==0x45&&Buffer[7]==0x49&&Buffer[8]==0x03&&Buffer[9]==0x0d))
			{
             MessageBox(NULL,"Card Data error!", "Error",MB_OK);//Before real data,there will 02 45 48 03 0e right data, 02 45 49 03 0d error data
			}
			else if((r>5)&&(Buffer[0] == 0x02))
			{
				pDlg->IsCardSend = TRUE; 
				Buffer[r] = 0;
				HID_Data[0]=0x00;
				if(Buffer[0]==0x02&&Buffer[1]==0x45&&Buffer[2]==0x4a&&Buffer[3]==0x03&&Buffer[4]==0x0e)
				{
                for (int i=5; i<(int)r; i++)
				{
					HID_Data[i+1-5] = Buffer[i];
					StrTmp.Format("%02X", Buffer[i]);
					StrCardData += StrTmp;
				}

				if (Buffer[r-1] == 0x03)
				{	
					HID_Data_Length = r+1-5;
				}
				else 
				{
					Sleep(1500);
					rr = pDlg->Device.Read(Buffer, sizeof(Buffer) -1,2000);
					
					Buffer[rr] = 0;
					for (int ii=0; ii<(int)rr; ii++)
					{
						HID_Data[r+ii+1] = Buffer[ii];
						StrTmp.Format("%02X", Buffer[ii]);
						StrCardData += StrTmp;
					}
					//lrc
				/*	for(int jj=0; jj<(int)rr; jj++)
						Lrc^= Buffer[jj];
					Buffer[rr]=Lrc;
					StrTmp.Format("%02X", Buffer[rr]);
					StrCardData += StrTmp; */

					HID_Data_Length = r+rr+1-5;
				}
				}
				else if(Buffer[5]==0x02&&Buffer[6]==0x45&&Buffer[7]==0x4a&&Buffer[8]==0x03&&Buffer[9]==0x0e)
				{

				for (int i=10; i<(int)r; i++)
				{
					HID_Data[i+1-10] = Buffer[i];
					StrTmp.Format("%02X", Buffer[i]);
					StrCardData += StrTmp;
				}

				if (Buffer[r-1] == 0x03)
				{	
					HID_Data_Length = r+1-10;
				}
				else 
				{
					Sleep(1500);
					rr = pDlg->Device.Read(Buffer, sizeof(Buffer) -1,2000);
					
					Buffer[rr] = 0;
					for (int ii=0; ii<(int)rr; ii++)
					{
						HID_Data[r+ii+1] = Buffer[ii];
						StrTmp.Format("%02X", Buffer[ii]);
						StrCardData += StrTmp;
					}
					//lrc
				/*	for(int jj=0; jj<(int)rr; jj++)
						Lrc^= Buffer[jj];
					Buffer[rr]=Lrc;
					StrTmp.Format("%02X", Buffer[rr]);
					StrCardData += StrTmp; */

					HID_Data_Length = r+rr+1-10;
				}
				}
				else {
					for (int i=0; i<(int)r; i++)
				{
					HID_Data[i+1] = Buffer[i];
					StrTmp.Format("%02X", Buffer[i]);
					StrCardData += StrTmp;
				}

				if (Buffer[r-1] == 0x03)
				{	
					HID_Data_Length = r+1;
				}
				else 
				{
					Sleep(1500);
					rr = pDlg->Device.Read(Buffer, sizeof(Buffer) -1,2000);
					
					Buffer[rr] = 0;
					for (int ii=0; ii<(int)rr; ii++)
					{
						HID_Data[r+ii+1] = Buffer[ii];
						StrTmp.Format("%02X", Buffer[ii]);
						StrCardData += StrTmp;
					}
					//lrc
				/*	for(int jj=0; jj<(int)rr; jj++)
						Lrc^= Buffer[jj];
					Buffer[rr]=Lrc;
					StrTmp.Format("%02X", Buffer[rr]);
					StrCardData += StrTmp; */

					HID_Data_Length = r+rr+1;
				}
			
				}
				
				pDlg->GetDlgItem(IDC_COMMAND)->SetWindowText(StrCardData);
			}
		}
	//	Sleep(1000);
	//	pDlg->IsCardSend = FALSE;
	}
}		

void CKeyInjectModuleDlg::OnButtonConnect() 
{
	// TODO: Add your control notification handler code here
	CString ComStr,temp;
	m_ComboDev.GetWindowText(temp);
	ComStr = L"\\\\.\\" + temp;
	if (!IsOpen)
	{
		int res = Device.Open(ComStr);
		if (res == TRUE)
		{
			IsOpen = TRUE;	
			//ʹ֮ˢ
			//53 19 01 35
			const int outLength = 7;
			BYTE datapool[outLength]; 
			datapool[0] = 0x02;
			datapool[1] = 0x53;
			datapool[2] = 0x19;
			datapool[3] = 0x01;
			datapool[4] = 0x35;
			datapool[5] = 0x03;
			datapool[6] = 0x7F;
			SendBluetoothCommand(datapool, outLength);
			//53 D2 02 01 02
			const int outLengt= 8;
			BYTE datapoo[outLengt]; 
			datapoo[0] = 0x02;
			datapoo[1] = 0x53;
			datapoo[2] = 0xD2;
			datapoo[3] = 0x02;
			datapoo[4] = 0x01;
			datapoo[5] = 0x02;
			datapoo[6] = 0x03;
			datapoo[7] = 0x81;
			SendBluetoothCommand(datapoo, outLengt);
			//53 D3 02 01 03
			const int outLeng= 8;
			BYTE datapo[outLeng]; 
			datapo[0] = 0x02;
			datapo[1] = 0x53;
			datapo[2] = 0xD3;
			datapo[3] = 0x02;
			datapo[4] = 0x01;
			datapo[5] = 0x03;
			datapo[6] = 0x03;
			datapo[7] = 0x81;
			SendBluetoothCommand(datapo, outLeng);	
			
			//жbDecryptMode
			const int outLen = 5;
			BYTE da[outLen];
			da[0] = 0x02;
			da[1] = 0x52;
			da[2] = 0x4C;
			da[3] = 0x03;
			da[4] = 0x1f;
			//Open blue tooth ??
		//	if (IsOpen==1)
		//	{
				SendBluetoothCommand(da, outLen);
		//	}
			/*else
			{
				SendCommandRequest(da, outLen);
			}*/
			//SendCommandRequest(da, outLengt);
			CString SResponse,STmp;
			// Get command request and response string
			GetDlgItemText(IDC_RESP,SResponse);
			STmp=SResponse;
			STmp.Remove(_T(' ')); //remove space
			STmp.Remove(_T('\t')); //remove tab
			STmp.Remove(_T('\r')); //remove CR
			STmp.Remove(_T('\n')); //remove new line
			int DataPo = STmp.Find("0602");
			if (STmp.Mid(DataPo+4, 6)=="4C0131")
			{
				bDecryptMode=1;
			}
			else if (STmp.Mid(DataPo+4, 6)=="4C0132")
			{
				bDecryptMode=2;
			}
			else if (STmp.Mid(DataPo+4, 6)=="4C0130")
			{
				bDecryptMode=0;
			}

			GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
			GetDlgItem(IDC_RESP)->SetWindowText(_T(""));
			
			MessageBox("Open Bluetooth successfully !");
			GetDlgItem(IDC_BUTTON_CONNECT)->SetWindowText("Disconnect");
			
			Sleep(1000);
			HANDLE hHND;
			hHND = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)DevThread,this,0,NULL);
			CloseHandle(hHND);
		}
		else 
		{
			IsOpen = FALSE;
			MessageBox("Fail to open comport!");
		}
	}
	else
	{
		OnMENUBTClose();
	}
}

void CKeyInjectModuleDlg::OnMENUBTClose() 
{
	// TODO: Add your command handler code here
	if ((IsOpen)&&(!IsSend)&&(!IsCardSend))
	{
		Device.Close();
		IsOpen=0;
		GetDlgItem(IDC_BUTTON_CONNECT)->SetWindowText("Connect");
		GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
		GetDlgItem(IDC_RESP)->SetWindowText(_T(""));
		MessageBox("Close Bluetooth successfully !");
	}
}


CKeyInjectModuleDlg::~CKeyInjectModuleDlg()
{
	if (IsOpen)
	{
		Device.Close();
	}
}
